/************************************************************
3217 Phoenixville Pike
Malvern, PA  19355
800 321-5355 or 610 725-8800
http://www.lawsonlabs.com
VC++ demo. program for M40x A/D board,
Uses DLL: M40x.DLL to access M401
*************************************************************/


// M40xVCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "M40xVC.h"
#include "SE_Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CM40xVCApp theApp;
extern INDEX_CONTEXT  Context[MAX_M401];
extern UINT uSelected_Index;
CString FormatVolt(double fVolt, UINT uIndex);
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CStatic	m_Dll_Ver;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CString GetDllVer(char *sModule);
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************************
*
*   Function:			CM40xVCDlg()
*	description:		Constructor
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
CM40xVCDlg::CM40xVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CM40xVCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hIconGray= AfxGetApp()->LoadIcon(IDI_GRAY);
	m_hIconBlue= AfxGetApp()->LoadIcon(IDI_BLUE);
	m_port = 23;
	m_ip = _T("10.1.1.2");
	m_subnetmask = _T("255.255.0.0");
	m_gateway_ip = _T("10.1.1.255");
	bDHCP_tmout = 2;		//default settings
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	InitAllFonts();
	m_pFont1 = new CFont();
	m_pFont1->CreateFontIndirect(&m_Font1);
	m_pFont2 = new CFont();
	m_pFont2->CreateFontIndirect(&m_Font2);
	m_bkColor0 = RGB(128,255,255);
	bkBrush.CreateSolidBrush(m_bkColor0);
	m_pYlwPen = new CPen(PS_SOLID,1,RGB(200,250,10));
	m_pBlkPen = new CPen(PS_SOLID,1,RGB(0,0,0));
	flgUsingThreadForDataAcq = FALSE;
	flgNoCallback = FALSE;
	flgWaitForIndexSwitch = FALSE;	
	pMutex = NULL;
	pMutex = new CMutex();
	if(pMutex == NULL)
		AfxMessageBox("Failed to create mutex");	
	bNetworkPollThreadPriority = 0;
	bNetworkEventThreadPriority = 5;
}

/****************************************************************************
*
*   Function:			CM40xVCDlg::~CM40xVCDlg()
*	description:		Destructor
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
CM40xVCDlg::~CM40xVCDlg()
{
	if(m_pFont1) delete m_pFont1;
	if(m_pFont2) delete m_pFont2;
	if(m_pYlwPen) delete m_pYlwPen;
	if(m_pBlkPen) delete m_pBlkPen;
	if(m_pTableDef ) delete m_pTableDef;
	if(m_pDatabase) delete m_pDatabase;
	if(pMutex != NULL)
		delete pMutex;
}

/****************************************************************************
*
*   Function:			DoDataExchange(CDataExchange* pDX)
*	description:		
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CM40xVCDlg)	
	DDX_Control(pDX, IDC_MAXMIN_RESET, m_BtnResetMaxMin);
	DDX_Control(pDX, IDC_EX_SCAN_SETUP, m_BtnExScanSetup);
	DDX_Control(pDX, IDC_CHK_EXTENDED, m_ChkExtended);
	DDX_Control(pDX, IDC_SCAN_ERROR, m_Scan_Error);
	DDX_Control(pDX, IDC_DATA_ACQ_METHOD, m_data_acq_method);
	DDX_Control(pDX, IDC_IP_ADDRESS_COMBO, m_ip_address_combo);
	DDX_Control(pDX, IDC_TIME, m_Time);
	DDX_Control(pDX, IDC_Show_Error, m_Show_Error);	
	DDX_Control(pDX, IDC_SCAN_COUNT, m_scan_counts);
	DDX_Control(pDX, IDC_SETRTC, m_set_rtc);
	DDX_Control(pDX, IDC_SELF_TEST, m_self_test);
	DDX_Control(pDX, IDC_INITIALIZATION, m_init_dev);
	DDX_Control(pDX, IDC_SYS_CAL, m_sys_cal_btn);
	DDX_Control(pDX, IDC_SET_RATE, m_set_rate_btn);
	DDX_Control(pDX, IDC_SCAN_RATE, m_scan_rate);
	DDX_Control(pDX, IDC_DAC2_OUTPUT, m_dac2_output);
	DDX_Control(pDX, IDC_DAC2_EDIT, m_dac2_edit);
	DDX_Control(pDX, IDC_DAC1_OUTPUT, m_dac1_output);
	DDX_Control(pDX, IDC_DAC1_EDIT, m_dac1_edit);
	DDX_Control(pDX, IDC_DAC0_OUTPUT, m_dac0_output);
	DDX_Control(pDX, IDC_DAC0_EDIT, m_dac0_edit);
	DDX_Control(pDX, IDC_END_SCAN, m_end_scan);
	DDX_Control(pDX, IDC_START_BTN, m_start_btn);
	DDX_Control(pDX, IDC_CAL_SCAN, m_cal_scan_check);
	DDX_Control(pDX, IDC_NUM_CHAN, m_num_of_chan);
	DDX_Control(pDX, IDC_MULTI_CHAN, m_multi_chan);
	DDX_Control(pDX, IDC_EVT_LOG_SAVE, m_event_log_save_checked);
	DDX_Control(pDX, IDC_EVENT_LOG, m_evt_log_wnd);
	DDX_Control(pDX, IDC_RATE_EDIT, m_rate_edit);
	DDX_Control(pDX, IDC_SEC_P_DIV, m_sec_p_div);
	DDX_Control(pDX, IDC_CHAN_SEL, m_chan_sel);
	DDX_Control(pDX, IDC_VOLT_DIV_COMBO, m_volt_div_combo);
	DDX_Control(pDX, IDC_DC_AC, m_dc_ac_sel);
	DDX_Control(pDX, IDC_LCD_SCRN, m_lcd_screen);
	DDX_Control(pDX, IDC_AVG_COMBO, m_avg_combo);
	DDX_Control(pDX, IDC_EFF_BITS, m_effective_bits);
	DDX_Control(pDX, IDC_DELTA_DSP, m_delta_dsp);
	DDX_Control(pDX, IDC_DEV_DSP, m_std_devi);
	DDX_Control(pDX, IDC_MIN_DSP, m_min_dsp);
	DDX_Control(pDX, IDC_MAX_DSP, m_max_dsp);
	DDX_Control(pDX, IDC_SCAN_LOG_FILE, m_save_log_file);
	DDX_Control(pDX, IDC_V0, m_read_v0);
	DDX_Control(pDX, IDC_V1, m_read_v1);
	DDX_Control(pDX, IDC_V2, m_read_v2);
	DDX_Control(pDX, IDC_V3, m_read_v3);
	DDX_Control(pDX, IDC_V4, m_read_v4);
	DDX_Control(pDX, IDC_V5, m_read_v5);
	DDX_Control(pDX, IDC_V6, m_read_v6);
	DDX_Control(pDX, IDC_V7, m_read_v7);
	DDX_Control(pDX, IDC_CH0, m_sel_ch0);
	DDX_Control(pDX, IDC_CH1, m_sel_ch1);
	DDX_Control(pDX, IDC_CH2, m_sel_ch2);
	DDX_Control(pDX, IDC_CH3, m_sel_ch3);
	DDX_Control(pDX, IDC_CH4, m_sel_ch4);
	DDX_Control(pDX, IDC_CH5, m_sel_ch5);
	DDX_Control(pDX, IDC_CH6, m_sel_ch6);
	DDX_Control(pDX, IDC_CH7, m_sel_ch7);
	DDX_Control(pDX, IDC_LED_RED8, m_led_red8);
	DDX_Control(pDX, IDC_LED_RED7, m_led_red7);
	DDX_Control(pDX, IDC_LED_RED6, m_led_red6);
	DDX_Control(pDX, IDC_LED_RED5, m_led_red5);
	DDX_Control(pDX, IDC_LED_RED4, m_led_red4);
	DDX_Control(pDX, IDC_LED_RED3, m_led_red3);
	DDX_Control(pDX, IDC_LED_RED2, m_led_red2);
	DDX_Control(pDX, IDC_LED_RED1, m_led_red1);
	DDX_Control(pDX, IDC_LED_GRAY8, m_led_gray8);
	DDX_Control(pDX, IDC_LED_GRAY7, m_led_gray7);
	DDX_Control(pDX, IDC_LED_GRAY6, m_led_gray6);
	DDX_Control(pDX, IDC_LED_GRAY5, m_led_gray5);
	DDX_Control(pDX, IDC_LED_GRAY4, m_led_gray4);
	DDX_Control(pDX, IDC_LED_GRAY3, m_led_gray3);
	DDX_Control(pDX, IDC_LED_GRAY2, m_led_gray2);
	DDX_Control(pDX, IDC_LED_GRAY1, m_led_gray1);
	DDX_Control(pDX, IDC_DO_D0, m_do_d0);
	DDX_Control(pDX, IDC_DO_D1, m_do_d1);
	DDX_Control(pDX, IDC_DO_D2, m_do_d2);
	DDX_Control(pDX, IDC_DO_D3, m_do_d3);
	DDX_Control(pDX, IDC_DO_D4, m_do_d4);
	DDX_Control(pDX, IDC_DO_D5, m_do_d5);
	DDX_Control(pDX, IDC_DO_D6, m_do_d6);
	DDX_Control(pDX, IDC_DO_D7, m_do_d7);
	DDX_Control(pDX, IDC_CONNECT, m_connect);
	DDX_Control(pDX, IDC_POLLED_RADIO, m_polled_radio);
	DDX_Control(pDX, IDC_SCAN_RADIO, m_scan_radio);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CM40xVCDlg, CDialog)
	//{{AFX_MSG_MAP(CM40xVCDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_GOEXIT, OnExit)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_START_BTN, OnStartBtn)
	ON_BN_CLICKED(IDC_SETRTC,OnSetRTC)
	ON_BN_CLICKED(IDC_END_SCAN, OnEndScan)
	ON_BN_CLICKED(IDC_SYS_CAL, OnSysCal)
	ON_BN_CLICKED(IDC_INITIALIZATION, OnInitialization)
	ON_CBN_SELCHANGE(IDC_AVG_COMBO, OnSelchangeAvgCombo)
	ON_BN_CLICKED(IDC_DO_D7, OnDoD7)
	ON_BN_CLICKED(IDC_DO_D6, OnDoD6)
	ON_BN_CLICKED(IDC_DO_D5, OnDoD5)
	ON_BN_CLICKED(IDC_DO_D4, OnDoD4)
	ON_BN_CLICKED(IDC_DO_D3, OnDoD3)
	ON_BN_CLICKED(IDC_DO_D2, OnDoD2)
	ON_BN_CLICKED(IDC_DO_D1, OnDoD1)
	ON_BN_CLICKED(IDC_DO_D0, OnDoD0)
	ON_BN_CLICKED(IDC_CH0, OnCh0)
	ON_BN_CLICKED(IDC_CH1, OnCh1)
	ON_BN_CLICKED(IDC_CH2, OnCh2)
	ON_BN_CLICKED(IDC_CH3, OnCh3)
	ON_BN_CLICKED(IDC_CH4, OnCh4)
	ON_BN_CLICKED(IDC_CH5, OnCh5)
	ON_BN_CLICKED(IDC_CH6, OnCh6)
	ON_BN_CLICKED(IDC_CH7, OnCh7)
	ON_CBN_SELCHANGE(IDC_VOLT_DIV_COMBO, OnSelChangVoltDivComb)
	ON_CBN_SELCHANGE(IDC_DC_AC,OnSelChangDcAcComb)
	ON_BN_CLICKED(IDC_MULTI_CHAN, OnMultiChan)
	ON_CBN_SELCHANGE(IDC_NUM_CHAN, OnSelchangeNumChan)
	ON_BN_CLICKED(IDC_CAL_SCAN, OnCalScan)
	ON_CBN_SELCHANGE(IDC_CHAN_SEL, OnSelchangeChanSel)
	ON_BN_CLICKED(IDC_POLLED_RADIO, OnPolledRadio)
	ON_BN_CLICKED(IDC_SCAN_RADIO, OnScanRadio)
	ON_BN_CLICKED(IDC_MAXMIN_RESET, OnMaxminReset)
	ON_BN_CLICKED(IDC_SET_RATE, OnSetRate)
	ON_BN_CLICKED(IDC_SELF_TEST, OnSelfTest)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_CBN_EDITUPDATE(IDC_AVG_COMBO, OnEditAvgCombo)
	ON_BN_CLICKED(ID_HELP, OnHelp)
	ON_CBN_EDITCHANGE(IDC_IP_ADDRESS_COMBO, OnEditchangeIpAddressCombo)	
	ON_CBN_SELCHANGE(IDC_IP_ADDRESS_COMBO, OnSelchangeIpAddressCombo)
	ON_BN_CLICKED(IDC_EVT_LOG_SAVE, OnEvtLogSave)
	ON_BN_CLICKED(IDC_Show_Error, OnShowError)
	ON_BN_CLICKED(IDC_IN_HOUSE_ONLY, OnInHouseOnly)
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(IDC_THREAD_PRIORITY_HIGHEST, OnThreadPriorityHighest)
	ON_COMMAND(IDC_THREAD_PRIORITY_ABOVE_NORMAL, OnThreadPriorityAboveNormal)
	ON_COMMAND(IDC_THREAD_PRIORITY_NORMAL, OnThreadPriorityNormal)
	ON_COMMAND(IDC_THREAD_PRIORITY_BELOW_NORMAL, OnThreadPriorityBelowNormal)
	ON_COMMAND(IDC_THREAD_PRIORITY_LOWEST, OnThreadPriorityLowest)
	ON_COMMAND(IDC_THREAD_PRIORITY_IDLE, OnThreadPriorityIdle)
	ON_BN_CLICKED(IDC_EX_SCAN_SETUP, OnExScanSetup)
	ON_BN_CLICKED(IDC_CHK_EXTENDED, OnChkExtended)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_WM_CLOSE()
	ON_COMMAND(ID_FILE_RTCHOSTTIMEDIFF, OnFileRtchosttimediff)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////


/**********************************************************
Function:	

Input: 

Return: 


Desc: 
		

Changes:
		
**********************************************************/


// Function documentation prototype




// CM40xVCDlg message handlers

/******************************************************************************
FUNCTION:			OnInitDialog()

DESCRIPTION:

  *	Init various dialog controls

  * Init context of all indices

  * Load saved settings of indices

  * Create a timer to update clock(1sec) 

  * Set selected index to 0, adjust dialog controls to index 0's last saved settings	

  * Check Callback.cfg to determine which method to use get scan data from the dll. 
     The different methods with corresponding setting in callback.cfg are:
	 - Default, Callback into application when dll has new scan data.(Single Threaded)
	   Callback.cfg settings: no callback.cfg file needed
	 - Dll uses a polling thread. And application uses a timer to poll dll for new data
	   Callback.cfg settings: NO_CALLBACK
	 - Dll uses a polling thread. And application uses a thread to poll dll for new data.
	   Callback.cfg settings: NO_CALLBACK and USE_THREAD (on separate lines)
	 - Dll uses a network event thread. Callback called as soon as new scan data arrives
	   Callback.cfg settings: EVENT_THREAD
	 - Dll uses a network event thread. And application uses a timer to poll dll for new
	   data.Callback.cfg settings:EVENT_THREAD and NO_CALLBACK(on separate lines)
	 - Dll uses a network event thread. And application uses a thread to poll dll for new 
	   data. Callback.cfg settings:EVENT_THREAD, NO_CALLBACK and USE_THREAD (all on separate
	   lines)
	  See M401.txt for more details on the different methods

  * For the identified method perform initialization and registrations, if any.

  



RETURN
	TRUE

*******************************************************************************/

BOOL CM40xVCDlg::OnInitDialog()
{
	CHARFORMAT cf;
	CDialog::OnInitDialog();
	CString str;
	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu*		pSysMenu;
	pSysMenu = GetSystemMenu(FALSE);
	theApp.pMyMenu =  this->GetMenu();
	if(theApp.pMyMenu != NULL){
		theApp.pMyMenu->EnableMenuItem(ID_CONFIG_CONFIGM40X,MF_GRAYED);
	}
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	// TODO: Add extra initialization here
//	m_ip_address.SetWindowText(m_ip);
//	CWnd *pWnd = GetDlgItem(IDC_IP_ADDRESS_COMBO);
//	m_ip_address_combo.SubclassWindow(pWnd->m_hWnd);
	BYTE i;
	bIsEverConnected = FALSE;		//flag to indicate if everconnected
	m_pChanReading[0] = &m_read_v0;
	m_pChanReading[1] = &m_read_v1;
	m_pChanReading[2] = &m_read_v2;
	m_pChanReading[3] = &m_read_v3;
	m_pChanReading[4] = &m_read_v4;
	m_pChanReading[5] = &m_read_v5;
	m_pChanReading[6] = &m_read_v6;
	m_pChanReading[7] = &m_read_v7;

	m_pDigiOut[0] = &m_do_d0;
	m_pDigiOut[1] = &m_do_d1;
	m_pDigiOut[2] = &m_do_d2;
	m_pDigiOut[3] = &m_do_d3;
	m_pDigiOut[4] = &m_do_d4;
	m_pDigiOut[5] = &m_do_d5;
	m_pDigiOut[6] = &m_do_d6;
	m_pDigiOut[7] = &m_do_d7;

	m_pChanSel[0] = &m_sel_ch0;
	m_pChanSel[1] = &m_sel_ch1;
	m_pChanSel[2] = &m_sel_ch2;
	m_pChanSel[3] = &m_sel_ch3;
	m_pChanSel[4] = &m_sel_ch4;
	m_pChanSel[5] = &m_sel_ch5;
	m_pChanSel[6] = &m_sel_ch6;
	m_pChanSel[7] = &m_sel_ch7;
	for(i = 0; i < MAX_CHANNELS; i++){
		m_pChanReading[i]->SetFont(m_pFont1,TRUE);
	}
	m_avg_combo.SetCurSel(2);
	bChanScanAvg = 1 << m_avg_combo.GetCurSel();
	m_dc_ac_sel.SetCurSel(1);
	m_chan_sel.SetCurSel(0);//select channel 0
	m_rate_edit.SetWindowText("1000");
	m_volt_div_combo.SetCurSel(2);//select 1mV 
	bIsAC = (m_dc_ac_sel.GetCurSel() == 1);
	fOffSet = 0;
	GraphDC.Attach((m_lcd_screen.GetDC())->GetSafeHdc());
	m_lcd_screen.GetClientRect(&LCD_RECT);
	ulPixPer10thScaleY = (UINT)(LCD_RECT.bottom / 10);
	ulPixPer10thScaleX = (UINT)(LCD_RECT.right / 10);
	GraphDC.SetBkColor(m_bkColor0);
	GraphDC.FillRect(&LCD_RECT,&bkBrush);
	ulCenter = LCD_RECT.bottom / 2;
	SaveMemDC.CreateCompatibleDC(&GraphDC);
	MemDC.CreateCompatibleDC(&GraphDC);	
	MemBmp.CreateCompatibleBitmap(&GraphDC,LCD_RECT.right, LCD_RECT.bottom);
	SaveBmp.CreateCompatibleBitmap(&GraphDC,LCD_RECT.right, LCD_RECT.bottom);
	SaveMemDC.SelectObject(&SaveBmp);
	MemDC.SelectObject(&MemBmp);
	m_lcd_screen.Invalidate();
	OnSelChangVoltDivComb();
	bCurSelChan = 0;
	m_pChanSel[bCurSelChan]->SetCheck(1);

	Init_Index_Context();
	LoadAllSettings();
	uSelected_Index=0;
	// check is user wants to use thread for data acq
	flgUsingEventThread = CheckForKeyword("EVENT_THREAD");
	flgNoCallback = CheckForKeyword("NO_CALLBACK");	



	UpdateClockID = SetTimer(5,1000,OnTimerProc);
	// set timer to get scan data from dll
	for(i=0;i<MAX_M401;i++){
		pEventLogFile[i] = NULL;
		pScanDataLogFile[i] = NULL;
		str.Format("%d = %s",i,Context[i].sIP);
		m_ip_address_combo.AddString(str);
		//register DLL_Scan_obj, Scan_volts_buff structures of all indices with dll.		
		if(!theApp.pDLL_PtrTransfer(&theApp.DLL_Scan_volts_buff[i],&theApp.DLL_Scan_obj[i])){
				AfxMessageBox("Pub_PtrTransfer Failed....App wil Exit");
				return FALSE;
		}			

		if(flgUsingEventThread){
			//DLL using event thread. Check Callback or no callback ?
			theApp.pDLL_NetworkEventThread(&theApp.DLL_Scan_obj[i]);
			if(flgNoCallback){
				// set all indices to no callback so that they won't require a message pump
				if(!theApp.pDLL_NoCallback(&theApp.DLL_Scan_obj[i])){
					AfxMessageBox("Pub_NoCallback Failed....App wil Exit");
					return FALSE;
				}
			}
			else{
				if(!theApp.pDLL_SetCallBackFunc(&theApp.DLL_Scan_obj[i],OnBlockRecv)){			
					AfxMessageBox("Pub_SetCallBackFunc Failed....App wil Exit");
					return FALSE;
				}

			}		
		}
		else{
			//DLL NOT using event thread. Check Callback or no callback ?
			if(flgNoCallback){
				// set all indices to no callback so that they won't require a message pump
				if(!theApp.pDLL_NoCallback(&theApp.DLL_Scan_obj[i])){
					AfxMessageBox("Pub_NoCallback Failed....App wil Exit");
					return FALSE;
				}
			}
			else{
				if(!theApp.pDLL_SetCallBackFunc(&theApp.DLL_Scan_obj[i],OnBlockRecv)){			
					AfxMessageBox("Pub_SetCallBackFunc Failed....App wil Exit");
					return FALSE;
				}

			}	

		}
	}
	if(flgNoCallback){
		//USE A THREAD TO POLL DLL FOR NEW DATA
		flgUsingThreadForDataAcq = CheckForKeyword("USE_THREAD");
		if(flgUsingThreadForDataAcq){
			flgThreadRun = TRUE;
			pDataAcqThread = AfxBeginThread((AFX_THREADPROC) ThreadProc,NULL,THREAD_PRIORITY_LOWEST);
			if(pDataAcqThread == NULL)
				AfxMessageBox(" Failed to create data acq thread, no scan mode");	
			else{
				if(flgUsingEventThread){
					m_data_acq_method.SetWindowText("Event Thread - Thread");					
					SetMenuThreadPriority(bNetworkEventThreadPriority);
				}
				else{
					m_data_acq_method.SetWindowText("Thread");	
					SetMenuThreadPriority(bNetworkPollThreadPriority);
				}
			}
		}
		else{		
			TimerID = SetTimer(10,30,OnTimerProc);
			if(flgUsingEventThread){
				m_data_acq_method.SetWindowText("Event Thread - Timer");
				SetMenuThreadPriority(bNetworkEventThreadPriority);
			}
			else{
				m_data_acq_method.SetWindowText("Timer");
				SetMenuThreadPriority(bNetworkPollThreadPriority);
			}
		}
	}
	else{
		if(flgUsingEventThread){
			m_data_acq_method.SetWindowText("Event Thread - Callback");			
			SetMenuThreadPriority(bNetworkEventThreadPriority);
		}
		else{
			m_data_acq_method.SetWindowText("Callback");
			//In the default callback method no second thread is created in the dll:
			//hence there is no need for this menu 
			theApp.pMyMenu->EnableMenuItem(2,MF_GRAYED | MF_DISABLED |MF_BYPOSITION);
		}
	}
	nIP_Index = 0;
	m_ip_address_combo.SetCurSel(nIP_Index);	
//DBG	SubWndIntLock(FALSE);
	m_pDatabase = new CDaoDatabase;
	m_pTableDef = NULL;
	m_pRecordSet = NULL;		
	DisableShowError();
	CWnd *pWnd = m_ip_address_combo.GetWindow(GW_CHILD);
	if(pWnd != NULL){
		m_ip_edit.SubclassWindow(pWnd->m_hWnd);
		m_ip_edit.SetCallBack(EnterPressedInComboBox);
	}
	m_Scan_Error.GetDefaultCharFormat(cf);
	cf.crTextColor = RGB(0xff,0,0);
	cf.dwEffects &= (~CFE_AUTOCOLOR);
	cf.dwMask |= CFM_COLOR ;
	cf.dwMask |= CFM_BOLD;
	m_Scan_Error.SetBackgroundColor(0,GetSysColor(COLOR_MENU));
	m_Scan_Error.SetDefaultCharFormat(cf);	
	m_ExVoltDlg.Create(IDD_EX_SCAN_VOLTS,this);
	for(i=0;i<16;i++){
		m_ExVoltDlg.m_SAD0[i].SetFont(m_pFont1,TRUE);
		m_ExVoltDlg.m_SAD1[i].SetFont(m_pFont1,TRUE);
	}
	m_ExVoltDlg.m_SAD6.SetFont(m_pFont1,TRUE);
	m_ExVoltDlg.m_SAD7.SetFont(m_pFont1,TRUE);
	Restore_Index_Context();	
	ClsPlotScrn();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

/****************************************************************************
*
*   Function:			InitAllFonts() 
*	description:		Initialize all fonts used for the dialog
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::InitAllFonts()
{
	m_Font1.lfHeight = 20;
    m_Font1.lfWidth = 0;
    m_Font1.lfEscapement = 0;
    m_Font1.lfOrientation = 0;
    m_Font1.lfWeight = FW_NORMAL;
    m_Font1.lfItalic = 0;
    m_Font1.lfUnderline = 0;
    m_Font1.lfStrikeOut = 0;
    m_Font1.lfCharSet = ANSI_CHARSET;
    m_Font1.lfOutPrecision = OUT_DEFAULT_PRECIS;
    m_Font1.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    m_Font1.lfQuality = PROOF_QUALITY;
    m_Font1.lfPitchAndFamily = VARIABLE_PITCH | FF_DONTCARE;
	lstrcpy(m_Font1.lfFaceName, "Arial Bold");
	m_Font2.lfHeight = 15;
    m_Font2.lfWidth = 0;
    m_Font2.lfEscapement = 0;
    m_Font2.lfOrientation = 0;
    m_Font2.lfWeight = FW_BOLD;
    m_Font2.lfItalic = 0;
    m_Font2.lfUnderline = 0;
    m_Font2.lfStrikeOut = 0;
    m_Font2.lfCharSet = ANSI_CHARSET;
    m_Font2.lfOutPrecision = OUT_DEFAULT_PRECIS;
    m_Font2.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    m_Font2.lfQuality = PROOF_QUALITY;
    m_Font2.lfPitchAndFamily = VARIABLE_PITCH | FF_DONTCARE;
	lstrcpy(m_Font2.lfFaceName, "Arial Bold");
	
}

/****************************************************************************
*
*   Function:		OnSysCommand(UINT nID, LPARAM lParam)
*	description:		
*	input:				
*   output:			
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

//	If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

/****************************************************************************
*
*   Function:		OnDestroy()
*	description:	when dialog box is about destroyed	
					saved 
*	input:				
*   output:			
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);//quit help 
	CDialog::OnDestroy();
	Save_Index_Context();// save context of current index
	SaveAllSettings();// save setting of all indices in M40x.cfg file

}

//	If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

/****************************************************************************
*
*   Function:		OnPaint() 
*	description:	when dialog box is about to be redrawn
*	input:				
*   output:			
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
	//ClsPlotScrn();	
	GraphDC.StretchBlt(1,1,LCD_RECT.right-2,LCD_RECT.bottom-2,&SaveMemDC,1,1,LCD_RECT.right-2, LCD_RECT.bottom-2,SRCCOPY);
}

// The system calls this to obtain the cursor to display while the user drags
// the minimized window.

/****************************************************************************
*
*   Function:		OnConnect()
*	description:	
		
		  When "connect" box is clicked..........

		*	Check if entered IP is valid (Check_IP())
		
		*	Call dll func OpenConnection to connect to M401

		*	Get M401 subnet mask, gateway, DHCP timeout (Get_IP_Params())

		*	Call dll func SetRate to set scan rate

		*	Call dll func SysCal to perform system calibration

		*	Adjust dialog controls to reflect M401 is connected (SubWndIntLock(TRUE))

		
		  When "disconnect" box is clicked..........

		*	Call dll func CloseConnection to disconnect from M401

		*	Adjust dialog controls to reflect not connected to M401 (SubWndIntLock(FALSE))
					

*	input:				
*   output:			
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnConnect() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);//Call this member function to initialize data in a dialog box
	CString buttonText,s;
	m_connect.GetWindowText(buttonText);	
	if (buttonText == "&Connect"){
		m_ip_address_combo.GetWindowText(m_ip);		
		if(!Check_IP(m_ip,m_ip))
			return;
		m_ip_address_combo.SetCurSel(nIP_Index);
		m_connect.EnableWindow(FALSE);
		WriteLogEntry("Connecting to %s please wait....",m_ip);
		if(theApp.pDLL_OpenConnection(&theApp.DLL_Scan_obj[uSelected_Index],m_ip,m_port)){
				//save IP
			Context[uSelected_Index].sIP = m_ip;
			Get_IP_Params();
			Context[uSelected_Index].bIsConnected =1;			
			m_connect.SetWindowText("&Disconnect");
			WriteLogEntry("Connect %s OK",m_ip);			
			UpdateData(TRUE);
			//OnInitialization();
			OnSetRate();
			OnSysCal();			
			UpdateDigiOut();
			this->SetWindowText(m_ip);
			bIsEverConnected = TRUE;		//flag to indicate if everconnected

		}
		else{
			WriteLogEntry("Failed to connect %s",m_ip);
			theApp.pDLL_CloseConnection(&theApp.DLL_Scan_obj[uSelected_Index]);
			UpdateData(TRUE);
			bIsEverConnected = FALSE;		//flag to indicate if everconnected
		}
	}
	else if (buttonText == "&Disconnect"){
		theApp.pDLL_CloseConnection(&theApp.DLL_Scan_obj[uSelected_Index]);
		Context[uSelected_Index].bIsConnected =0;
		WriteLogEntry("Disconnect from %s",m_ip);
		m_connect.SetWindowText("&Connect");

		if(theApp.pMyMenu != NULL){
			UINT OK = theApp.pMyMenu->EnableMenuItem(ID_CONFIG_CONFIGM40X,MF_GRAYED);
		}
	}	
	UpdateGUIState();
}





/**********************************************************
Function:	OnEndScan() 

Input:		

Return:		


Desc:		
		Call Pub_EndScan to stop scanning. If Pub_EndScan returns
		PENDING, M401 has unsent scan data. Call Pub_EndScan repeatedly
		till return value is not PENDING for graceful stop scan. 
		Remeber to read new scan data while waiting for Pub_EndScan
		to succeed.		

Changes:
		
**********************************************************/

void CM40xVCDlg::OnEndScan() 
{
	// TODO: Add your control notification handler code here
	char ScanStartTime[20], ScanStopTime[20];
	double fScanDuration;
	RETURN_CODE DLLCallRet;
	DWORD dwDispTm;
	m_end_scan.EnableWindow(FALSE);
	dwDispTm = GetTickCount() + 2000;
	do{
		DLLCallRet = theApp.pDLL_EndScan(&theApp.DLL_Scan_obj[uSelected_Index]);
		//07.02.03
		if(flgNoCallback){			
			Sleep(100); //give slice to other threads
			if(!flgUsingThreadForDataAcq)
				ReadNewScanData();//no callback and using timer for data acq try to
		// get remaining data while waiting for end scan confirmation			
		}
		
		if((GetTickCount() > dwDispTm) && (DLLCallRet == PENDING)){
			//display result of Pub_EndScan every 2 secs
			WriteLogEntry("EndScan %s",theApp.pDLL_Error_Msg[DLLCallRet]);
			dwDispTm = GetTickCount() + 2000;
		}
	}
	while(DLLCallRet == PENDING);

	WriteLogEntry("EndScan %s",theApp.pDLL_Error_Msg[DLLCallRet]);	
	theApp.pMyMenu->EnableMenuItem(ID_CONFIG_CONFIGM40X,MF_ENABLED);	
	////
	if (theApp.pDLL_IsFirmwareVersion(&theApp.DLL_Scan_obj[uSelected_Index],8,23,2006)){
		DLLCallRet = theApp.pDLL_GetScanTime(&theApp.DLL_Scan_obj[uSelected_Index],ScanStartTime, ScanStopTime, &fScanDuration);
		if (DLLCallRet == COMMAND_OK){
			WriteLogEntry("Scan Start %s", ScanStartTime);
			WriteLogEntry("Scan Stop %s", ScanStopTime);
			WriteLogEntry("Duration %.3f",fScanDuration);
			if(pScanDataLogFile[uSelected_Index]){
				//Logging to file
				fprintf(pScanDataLogFile[uSelected_Index],"\nScan Started At :%s",ScanStartTime);
				fprintf(pScanDataLogFile[uSelected_Index],"\nScan Stopped At :%s",ScanStopTime);
				fprintf(pScanDataLogFile[uSelected_Index],"\nScan Duration :%.3f secs",fScanDuration);
			}		
		}
		else{
			WriteLogEntry("Pub_GetScanTime Failed >> %s",theApp.pDLL_Error_Msg[DLLCallRet]);
		}
	}
	////
	theApp.pdlg->CloseOpenFile();
	UpdateGUIState();
}



/****************************************************************************
*
*   Function:		OnSysCal() 
*	description:
			when "Sys cal" box is clicked

			*  Call dll func OfsCal to perform offset calibration

			*  Call dll func FsCal to perform full scale calibration
					
					
*	input:				
*   output:			
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnSysCal() 
{
	// TODO: Add your control notification handler code here
	double	fReading;
	wErr_ret = theApp.pDLL_OfsCal(&theApp.DLL_Scan_obj[uSelected_Index],&fReading);
	if (wErr_ret != COMMAND_OK){
		WriteLogEntry("Offset Cal. >> %s",theApp.pDLL_Error_Msg[wErr_ret]);
	}
	else{
		WriteLogEntry("Offset reading >> % 7.6f",fReading);
	}
	wErr_ret = theApp.pDLL_FsCal(&theApp.DLL_Scan_obj[uSelected_Index],&fReading);
	if (wErr_ret != COMMAND_OK){
		WriteLogEntry("Full scal Cal. >> %s",theApp.pDLL_Error_Msg[wErr_ret]);
	}
	else{
		WriteLogEntry("Full scal reading >> % 7.6f",fReading);
	}
	OnChComm(bCurSelChan);	
}

/****************************************************************************
*
*   Function:		OnInitialization() 
*	description:	
				when "Initialization" box is clicked

				Perform SetRate and SysCal
					
*	input:				
*   output:			
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnInitialization() 
{
	// TODO: Add your control notification handler code here
	OnSetRate();
	OnSysCal();
//	if(m_polled_radio.GetCheck() || !m_multi_chan.GetCheck()){
		//OnChComm(bCurSelChan);	
//	}
	UpdateDigiOut();
	OnChComm(bCurSelChan);	
}

/****************************************************************************
*
*   Function:			UpdateDigIn(BYTE bDigiStatus)
*	description:		Based on bDigiStatus, display LED in diff. color
*	input:				bDigiStatus
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::UpdateDigIn(BYTE bDigiStatus)
{

	if(bDigiStatus & 1){
		m_led_gray1.ShowWindow(SW_HIDE);
		m_led_red1.ShowWindow(SW_SHOW);
	}else{
		m_led_red1.ShowWindow(SW_HIDE);
		m_led_gray1.ShowWindow(SW_SHOW);
	}
	if(bDigiStatus & 2){
		m_led_gray2.ShowWindow(SW_HIDE);
		m_led_red2.ShowWindow(SW_SHOW);
	}else{
		m_led_red2.ShowWindow(SW_HIDE);
		m_led_gray2.ShowWindow(SW_SHOW);
	}
	if(bDigiStatus & 4){
		m_led_gray3.ShowWindow(SW_HIDE);
		m_led_red3.ShowWindow(SW_SHOW);
	}else{
		m_led_red3.ShowWindow(SW_HIDE);
		m_led_gray3.ShowWindow(SW_SHOW);
	}
	if(bDigiStatus & 8){
		m_led_gray4.ShowWindow(SW_HIDE);
		m_led_red4.ShowWindow(SW_SHOW);
	}else{
		m_led_red4.ShowWindow(SW_HIDE);
		m_led_gray4.ShowWindow(SW_SHOW);
	}
	if(bDigiStatus & 16){
		m_led_gray5.ShowWindow(SW_HIDE);
		m_led_red5.ShowWindow(SW_SHOW);
	}else{
		m_led_red5.ShowWindow(SW_HIDE);
		m_led_gray5.ShowWindow(SW_SHOW);
	}
	if(bDigiStatus & 32){
		m_led_gray6.ShowWindow(SW_HIDE);
		m_led_red6.ShowWindow(SW_SHOW);
	}else{
		m_led_red6.ShowWindow(SW_HIDE);
		m_led_gray6.ShowWindow(SW_SHOW);
	}
	if(bDigiStatus & 64){
		m_led_gray7.ShowWindow(SW_HIDE);
		m_led_red7.ShowWindow(SW_SHOW);
	}else{
		m_led_red7.ShowWindow(SW_HIDE);
		m_led_gray7.ShowWindow(SW_SHOW);
	}
	if(bDigiStatus & 128){
		m_led_gray8.ShowWindow(SW_HIDE);
		m_led_red8.ShowWindow(SW_SHOW);
	}else{
		m_led_red8.ShowWindow(SW_HIDE);
		m_led_gray8.ShowWindow(SW_SHOW);
	}
}

/****************************************************************************
*
*   Function:			OnSelchangeAvgCombo()
*	description:		When average combo box is changed
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnSelchangeAvgCombo() 
{
	// TODO: Add your control notification handler code here
	CString sTmp;
	m_avg_combo.GetWindowText(sTmp);
	bChanScanAvg = atoi(sTmp);
	if(bChanScanAvg > 32)
		bChanScanAvg = 32;	
	ulScanCnt = 0;
	WriteLogEntry("Average changed to %d",bChanScanAvg);
	theApp.DLL_Scan_obj[uSelected_Index].bChanScanAvg = bChanScanAvg;
	theApp.DLL_Scan_obj[uSelected_Index].ulScanCounts = 0;
}


// These 8 functions below get called when a checkbox is changed in the Digital Output section in the Dialog
void CM40xVCDlg::OnDoD7() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	

}

void CM40xVCDlg::OnDoD6() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
	
}

void CM40xVCDlg::OnDoD5() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
	
}

void CM40xVCDlg::OnDoD4() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
	
}

void CM40xVCDlg::OnDoD3() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
	
}

void CM40xVCDlg::OnDoD2() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
	
}

void CM40xVCDlg::OnDoD1() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
}

void CM40xVCDlg::OnDoD0() 
{
	// TODO: Add your control notification handler code here
	UpdateDigiOut();	
}

/****************************************************************************
*
*   Function:			UpdateDigiOut() 
*	description:		Update digital output
*						gets called from OnDoDx() functions
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::UpdateDigiOut()
{
	BYTE i;	
	bLastDigOut = 0;
	for(i = 0; i < 8; i++){
		bLastDigOut = bLastDigOut | m_pDigiOut[i]->GetCheck() << i;
	}
	if( (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == EXTENDED_SCAN) || (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == EXTENDED_CAL_SCAN) ){		
		theApp.pDLL_SetChan(&theApp.DLL_Scan_obj[uSelected_Index],GetExActiveChan());
		WriteLogEntry("Active AD chan %d, Sub chan %d",GetExActiveChan() >> 4, GetExActiveChan() & 0x0F);		
	}
	wErr_ret = theApp.pDLL_SetDigOut(&theApp.DLL_Scan_obj[uSelected_Index],bLastDigOut);
	WriteLogEntry("SetDigOut [%x] >> %s",bLastDigOut,theApp.pDLL_Error_Msg[wErr_ret]);
}

/****************************************************************************
*
*   Function:			PlotOnePixel(double fVoltage)
*	description:		Draw voltage curve window
*	input:				double fVoltage
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::PlotOnePixel(double fVoltage)
{
	INT nPlot_Y, nCols;
	double	fDeltaV, fSlope;	
	if((fPlot_X > (LCD_RECT.right-1))){
		if(bIsAC){
			fOffSet = -fOffSetVolt;//remember this for next time comparasion
			fDeltaV = fVoltage + fOffSet;
		}
		else{
			fDeltaV = -fVoltage;
		}
		nPlot_Y = (INT)(fDeltaV * fPixPerVolt);	
		nPlot_Y = ulCenter + nPlot_Y;
		//Check 'Y' limits
		if(nPlot_Y >= LCD_RECT.bottom){
			nPlot_Y = LCD_RECT.bottom - 2;
		}
		if(nPlot_Y <= 0){
			nPlot_Y = 1;
		}
		//calculate the point of intersection of the line segment
		//joining the last point to the current point with the right
		//edge of the graph.
		fSlope = (nPlot_Y - nLastPlot_Y)/(fPlot_X - nLastPlot_X);
		nPlot_Y = (int)(fSlope * ((LCD_RECT.right-1) - nLastPlot_X) + nLastPlot_Y);
		nCols = ((LCD_RECT.right-2) - nLastPlot_X);
		//If cols change from the last point to the current point then restore columns, .................
		GraphDC.BitBlt(nLastPlot_X+1,1, nCols, LCD_RECT.bottom-2, &MemDC, nLastPlot_X+1, 1, SRCCOPY);	
		SaveMemDC.BitBlt(nLastPlot_X+1,1, nCols, LCD_RECT.bottom-2, &MemDC, nLastPlot_X+1, 1, SRCCOPY);	
		SaveMemDC.MoveTo(nLastPlot_X, nLastPlot_Y);
		GraphDC.MoveTo(nLastPlot_X, nLastPlot_Y);
		SaveMemDC.LineTo((LCD_RECT.right-1), nPlot_Y);
		GraphDC.LineTo((LCD_RECT.right-1), nPlot_Y);//black pixel
		nLastPlot_X = 0;
		nLastPlot_Y = nPlot_Y;
		fPlot_X = fPlot_X - (LCD_RECT.right-1);	
	}	
	nCols = ((INT)fPlot_X - nLastPlot_X);
	//If cols change from the last point to the current point then restore columns, .................
	GraphDC.BitBlt(nLastPlot_X+1,1, nCols, LCD_RECT.bottom-2, &MemDC, nLastPlot_X+1, 1, SRCCOPY);	
	SaveMemDC.BitBlt(nLastPlot_X+1,1, nCols, LCD_RECT.bottom-2, &MemDC, nLastPlot_X+1, 1, SRCCOPY);	
	if(nLastPlot_X == 0){
		//Graph rolled over to start of screen, reset volt base for AC
		fOffSetVolt = fVoltage;
	}
	if(bIsAC){
		fOffSet = -fOffSetVolt;//remember this for next time comparasion
		fDeltaV = fVoltage + fOffSet;
	}
	else{
		fDeltaV = -fVoltage;
	}
	nPlot_Y = (INT)(fDeltaV * fPixPerVolt);	
	nPlot_Y = ulCenter + nPlot_Y;
	//check 'Y' limits
	if(nPlot_Y >= LCD_RECT.bottom){
		nPlot_Y = LCD_RECT.bottom - 2;
	}
	if(nPlot_Y <= 0){
		nPlot_Y = 1;
	}
	//..........m_bkSaved = GraphDC.GetPixel(nPlot_X, nPlot_Y);//save this first	
	//keep a copy of the current state of graph in SaveMemDC to be restored on refresh
	SaveMemDC.MoveTo(nLastPlot_X, nLastPlot_Y);
	GraphDC.MoveTo(nLastPlot_X, nLastPlot_Y);
	SaveMemDC.LineTo((int)fPlot_X, nPlot_Y);
	GraphDC.LineTo((int)fPlot_X, nPlot_Y);//black pixel
	nLastPlot_X = (int)fPlot_X;
	nLastPlot_Y = nPlot_Y;
	fPlot_X += fXPixPerDP;	
}


/****************************************************************************
*
*   Function:			OnSelChangVoltDivComb() 
*	description:		When volt/div combo box is changed
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnSelChangVoltDivComb()
{
	ClsPlotScrn();
}

/****************************************************************************
*
*   Function:			OnSelChangDcAcComb() 
*	description:		When AC/DC combo box is changed
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnSelChangDcAcComb()
{
	bIsAC = (m_dc_ac_sel.GetCurSel() == 1);
	ClsPlotScrn();
}


void CM40xVCDlg::OnCh0() 
{
	// TODO: Add your control notification handler code here
	//click channel 0 check box
	OnChComm(0);
}

void CM40xVCDlg::OnCh1() 
{
	// TODO: Add your control notification handler code here
	OnChComm(1);
}

void CM40xVCDlg::OnCh2() 
{
	// TODO: Add your control notification handler code here
	OnChComm(2);
}

void CM40xVCDlg::OnCh3() 
{
	// TODO: Add your control notification handler code here
	OnChComm(3);
}

void CM40xVCDlg::OnCh4() 
{
	// TODO: Add your control notification handler code here
	OnChComm(4);	
}

void CM40xVCDlg::OnCh5() 
{
	// TODO: Add your control notification handler code here
	OnChComm(5);
}

void CM40xVCDlg::OnCh6() 
{
	// TODO: Add your control notification handler code here
	OnChComm(6);	
}

void CM40xVCDlg::OnCh7() 
{
	// TODO: Add your control notification handler code here
	OnChComm(7);	
}


/****************************************************************************
*
*   Function:			OnChComm(BYTE bCHClicked) 
*	description:		When click one of eight channel selection check box
*	input:				BYTE bCHClicked
*   output:				
*	global variable:	
****************************************************************************/

void CM40xVCDlg::OnChComm(BYTE bCHClicked)
{
	BYTE i;	
	//when single channel in scan mode or in poll mode
	//only one channel should be selected
	bCurSelChan = bCHClicked;
	ClsPlotScrn();
	for(i = 0; i < 8; i++){
		m_pChanReading[i]->SetWindowText("       ");
		if(i == bCHClicked){
			m_pChanSel[i]->SetCheck(1);
			if((Context[uSelected_Index].bMODE == 1) || (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == SINGLE_CHAN_SCAN)){
				//polled, and single channel mode
				wErr_ret = theApp.pDLL_SetChan(&theApp.DLL_Scan_obj[uSelected_Index],bCurSelChan);
				WriteLogEntry("Set chan [%d]>> %s",bCurSelChan,theApp.pDLL_Error_Msg[wErr_ret]);
				theApp.DLL_Scan_obj[uSelected_Index].bSelChanOrNumOfChan = i;
			}
			else if((theApp.DLL_Scan_obj[uSelected_Index].bScanMode == EXTENDED_SCAN) || (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == EXTENDED_CAL_SCAN)){
				
				//Active channel selection - upper nibble AD chan, lower nibble sub chan
				theApp.pDLL_SetChan(&theApp.DLL_Scan_obj[uSelected_Index],GetExActiveChan());
				WriteLogEntry("Active AD chan %d, Sub chan %d",GetExActiveChan() >> 4, GetExActiveChan() & 0x0F);
			}
			else{

			}
		}
		else{
			m_pChanSel[i]->SetCheck(0);
		}
	}
}



/****************************************************************************
*
*   Function:			GetCurChanSel
*	description:		Get current channel selection
*	input:				
*   output:				0 - 7 depends on which channel is selected
*	global variable:	
****************************************************************************/
BYTE CM40xVCDlg::GetCurChanSel()
{
	BYTE i;
	for(i = 0; i < 8; i++){
		if(m_pChanSel[i]->GetCheck()) return i;
	}
	return 0;
}

/****************************************************************************
*
*   Function:			NumOfChan()
*	description:		Check how many channels are selected
*	input:				
*   output:				channel counts
*	global variable:	
****************************************************************************/
BYTE CM40xVCDlg::NumOfChan()
{
	BYTE i;
	CString sTmp;
	if(!m_multi_chan.GetCheck()) return 1;//single channel scan
	m_num_of_chan.GetWindowText(sTmp);
	i = atoi(sTmp);
	if(i > 4) i = 4;
	return i;
}

/****************************************************************************
*
*   Function:			OnMultiChan() 
*	description:		when click multichan check box
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnMultiChan() 
{
	// TODO: Add your control notification handler code here	
	if(m_multi_chan.GetCheck()){
		theApp.DLL_Scan_obj[uSelected_Index].bScanMode = MULT_CHAN_SCAN;
		
	}
	else{
		theApp.DLL_Scan_obj[uSelected_Index].bScanMode = SINGLE_CHAN_SCAN;
	}
	UpdateGUIState();
}

void CM40xVCDlg::OnSelchangeNumChan() 
{
	// TODO: Add your control notification handler code here
}


/****************************************************************************
*
*   Function:			EndScan()
*	description:		End scan
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::EndScan()
{
	OnEndScan();
}

/****************************************************************************
*
*   Function:			OnCalScan() 
*	description:		When click cal. scan check box
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnCalScan() 
{
	// TODO: Add your control notification handler code here
	if(m_cal_scan_check.GetCheck()){
		theApp.DLL_Scan_obj[uSelected_Index].bScanMode = MULT_CHAN_CAL_SCAN;
	}
	else{
		theApp.DLL_Scan_obj[uSelected_Index].bScanMode = MULT_CHAN_SCAN;
	}
	UpdateGUIState();
}


/****************************************************************************
*
*   Function:			OnSelchangeChanSel() 
*	description:		when plot channel is changed
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnSelchangeChanSel() 
{
	// TODO: Add your control notification handler code here
	ClsPlotScrn();
	bPlotSelChan = m_chan_sel.GetCurSel();//get plot channel 
}

/****************************************************************************
*
*   Function:			OnScanRadio() 
*	description:		When click scan radio box
*	input:
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnScanRadio() 
{
	// TODO: Add your control notification handler code here	
	Context[uSelected_Index].bMODE = 0;	//scanning mode
	UpdateGUIState();
}


/****************************************************************************
*
*   Function:			OnPolledRadio() 
*	description:		When click polled mode radio box
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnPolledRadio() 
{
	// TODO: Add your control notification handler code here
	Context[uSelected_Index].bMODE = 1;//polled mode
	UpdateGUIState();
	OnChComm(0);
}


/****************************************************************************
*
*   Function:			OnMaxminReset() 
*	description:		When click reset max/min button
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnMaxminReset() 
{
	// TODO: Add your control notification handler code here
	theApp.pDLL_ResetMinMax(&theApp.DLL_Scan_obj[uSelected_Index]);
}


/****************************************************************************
*
*   Function:			UpdateLabel()
*	description:		
				update labels on the dialog box
		*		Adjusts x axis scale based on current scan rate
	
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::UpdateLabel()
{
	CString strTmp;
	if(theApp.DLL_Scan_obj[uSelected_Index].bScanStopped)
		return;	//
	strTmp.Format("X:(%.2f Sec/Div)", fSecsPerScrn/10.0);
	m_sec_p_div.SetWindowText(strTmp);
	strTmp.Format("Scan rate:%4.3f",theApp.DLL_Scan_obj[uSelected_Index].fMultiChanScanRate);
	m_scan_rate.SetWindowText(strTmp);
	bPlotSelChan = m_chan_sel.GetCurSel();//get plot channel 

}

/****************************************************************************
*
*   Function:			ClsPlotScrn()
*	description:		Clean Plot screen
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::ClsPlotScrn()
{
	BYTE i,j;
	UINT x,y;
	nLastPlot_X = 0;
	nLastPlot_Y = 0;
	fSecsPerScrn = 5;
	j = m_volt_div_combo.GetCurSel();//0 - 1uV, 1 - 10uV .....
	fPixPerVolt = (float)LCD_RECT.bottom;	// how many dots/uV
	for(i = 0; i < j; i++){
		fPixPerVolt = fPixPerVolt * 0.1;
	}
	fPixPerVolt = fPixPerVolt * 100000.0;
	fXPixPerDP = ((LCD_RECT.right-1)/(fSecsPerScrn * theApp.DLL_Scan_obj[uSelected_Index].fMultiChanScanRate));
	GraphDC.FillRect(&LCD_RECT,&bkBrush);
	SaveMemDC.FillRect(&LCD_RECT,&bkBrush);
	GraphDC.SelectObject(m_pYlwPen);	
	SaveMemDC.SelectObject(m_pYlwPen);	
	y = ulPixPer10thScaleY;
	x = ulPixPer10thScaleX;
	//Draw graph area - 10 dotted rows and 10 dotted columns, corresponding to vertical and horizontal divisions
///*****************************************************************
	for(i = 1; i < 10;i++){
		for(j = 1; j < 10;j++){
			GraphDC.SetPixel(x,y,RGB(0,0,0));
			SaveMemDC.SetPixel(x,y,RGB(0,0,0));
			x = x + ulPixPer10thScaleX;
		}
		x = ulPixPer10thScaleX;
		y = y + ulPixPer10thScaleY;
	}
//******************************************************************/
	//Keep copy of blank graph panel in MemDC. All columns after the previous point to
	//the current point are restored before the current point in plotted. It is done to
	// erase line segments corresponding to previous points.
	if(MemDC.StretchBlt(0,0,LCD_RECT.right,LCD_RECT.bottom,&GraphDC,0,0,LCD_RECT.right, LCD_RECT.bottom,SRCCOPY) == 0){
		AfxMessageBox("MemDC.StretchBlt Failed");
	}
	GraphDC.SelectObject(m_pBlkPen);
	SaveMemDC.SelectObject(m_pBlkPen);
	fPlot_X = 0;//start over
	fOffSet = 0;
	m_lcd_screen.Invalidate(TRUE);
}

/****************************************************************************
*
*   Function:			OnStartBtn() 
*	description:		when start button is clicked, it starts scan
*						or call get conversion in polled mode
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnStartBtn() 
{
	// TODO: Add your control notification handler code here
	BYTE bLastDigIn;
	int nNumOfExScanChans;
	double fReading;		
	if(Context[uSelected_Index].bMODE == 1){		
		//POLLED MODE
		wErr_ret = theApp.pDLL_GetPolledConv(&theApp.DLL_Scan_obj[uSelected_Index],&fReading,&bLastDigIn);
		WriteLogEntry("Get Conversion >> %s",theApp.pDLL_Error_Msg[wErr_ret]);
		if(wErr_ret == COMMAND_OK){			
			m_pChanReading[GetCurChanSel()]->SetWindowText(FormatVolt(fReading,uSelected_Index));
			UpdateDigIn(bLastDigIn);
		}
		UpdateLabel();	
	}
	else{
		//ONE OF THE SCANNING MODES
//		ClsPlotScrn();
		OnSelchangeAvgCombo();	//update bChanScanAvg
		if( (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == EXTENDED_SCAN) || (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == EXTENDED_CAL_SCAN) ){		
			//EXTENDED SCAN/CAL SCAN
			// SET THE FIRST SELECTED CHANNEL AS THE ACTIVE CHANNEL FOR MAX, MIN, EFF-BITS CALCULATION
			nNumOfExScanChans = 0;
			if(Context[uSelected_Index].ExtScan_AD0_Start >=0){								
				nNumOfExScanChans += (Context[uSelected_Index].ExtScan_AD0_End - Context[uSelected_Index].ExtScan_AD0_Start) + 1; 
				bCurSelChan = 0; 
				SetSubChan((BYTE)(Context[uSelected_Index].ExtScan_AD0_Start));					
			}
			else if(Context[uSelected_Index].ExtScan_AD1_Start >=0){			
				nNumOfExScanChans += (Context[uSelected_Index].ExtScan_AD1_End - Context[uSelected_Index].ExtScan_AD1_Start) + 1; 
				bCurSelChan = 1; 
				SetSubChan((BYTE)(Context[uSelected_Index].ExtScan_AD1_Start));					

			}
			else if(Context[uSelected_Index].ExtScan_AD6){						
				nNumOfExScanChans++;
				bCurSelChan = 6;
				SetSubChan(0);
			}
			else{			
				if(Context[uSelected_Index].ExtScan_AD7){
					nNumOfExScanChans++;
					bCurSelChan = 7;
					SetSubChan(0);
				}
			}
			if(nNumOfExScanChans == 0){
				AfxMessageBox("Select atleast one channel before starting extended scan. Click on ExScanSetup button to select channels");
			}
			else{
				theApp.pDLL_ResetScanDataObj(&theApp.DLL_Scan_obj[uSelected_Index],theApp.DLL_Scan_obj[uSelected_Index].bScanMode,bScanChanCnt,bChanScanAvg,theApp.DLL_Scan_obj[uSelected_Index].fScanRate);//reset scan data object
				if(theApp.pDLL_ExtendedScan(&theApp.DLL_Scan_obj[uSelected_Index],Context[uSelected_Index].ExtScan_AD0_Start,Context[uSelected_Index].ExtScan_AD0_End,Context[uSelected_Index].ExtScan_AD1_Start,Context[uSelected_Index].ExtScan_AD1_End,Context[uSelected_Index].ExtScan_AD6,Context[uSelected_Index].ExtScan_AD7,Context[uSelected_Index].bExtCalScan,Context[uSelected_Index].bMuxInverted)){										
					Context[uSelected_Index].ulExScanCounts = 0;
					SaveScanDataDlg();			
					theApp.pDLL_SetChan(&theApp.DLL_Scan_obj[uSelected_Index],GetExActiveChan());
					WriteLogEntry("Active AD chan %d, Sub chan %d",GetExActiveChan() >> 4, GetExActiveChan() & 0x0F);					
					Context[uSelected_Index].bChanSel = bCurSelChan;
				}
				else{					
					WriteLogEntry("ExtendedScan Failed >>");
				}
			}
		}
		else if( (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == MULT_CHAN_SCAN) || (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == MULT_CHAN_CAL_SCAN)){
			bScanChanCnt = NumOfChan() + 1 * (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == MULT_CHAN_CAL_SCAN);
			if(bScanChanCnt > 4) bScanChanCnt = 4;
			m_num_of_chan.SetCurSel(bScanChanCnt-1);
			theApp.pDLL_ResetScanDataObj(&theApp.DLL_Scan_obj[uSelected_Index],theApp.DLL_Scan_obj[uSelected_Index].bScanMode,bScanChanCnt,bChanScanAvg,theApp.DLL_Scan_obj[uSelected_Index].fScanRate);//reset scan data object
			SaveScanDataDlg();//check if we need to save scan data			
			bCurSelChan = 0;			
			wErr_ret = theApp.pDLL_StartScan(&theApp.DLL_Scan_obj[uSelected_Index],theApp.DLL_Scan_obj[uSelected_Index].bScanMode,bScanChanCnt);
			if(wErr_ret != COMMAND_OK){
				WriteLogEntry("FAILED multi-channel scan >> %s",theApp.pDLL_Error_Msg[wErr_ret]);
			}
			else{
				WriteLogEntry("Start multi-channel scan >> %s",theApp.pDLL_Error_Msg[wErr_ret]);
			}
		}
		else{
			bCurSelChan = GetCurChanSel();
			theApp.DLL_Scan_obj[uSelected_Index].bScanMode = SINGLE_CHAN_SCAN;						
			theApp.pDLL_ResetScanDataObj(&theApp.DLL_Scan_obj[uSelected_Index],theApp.DLL_Scan_obj[uSelected_Index].bScanMode,bCurSelChan,bChanScanAvg,theApp.DLL_Scan_obj[uSelected_Index].fScanRate);//reset scan data object
			SaveScanDataDlg();//check if we need to save scan data
			wErr_ret = theApp.pDLL_SetChan(&theApp.DLL_Scan_obj[uSelected_Index],bCurSelChan);
			strTmp.Format("Set Channel >> %s",theApp.pDLL_Error_Msg[wErr_ret]);
			Sleep(500);
			wErr_ret = theApp.pDLL_StartScan(&theApp.DLL_Scan_obj[uSelected_Index],theApp.DLL_Scan_obj[uSelected_Index].bScanMode,bCurSelChan);
			WriteLogEntry("Start single chan scan >> %s",theApp.pDLL_Error_Msg[wErr_ret]);
			Context[uSelected_Index].bChanSel = bCurSelChan;
			UpdateLabel();
		}
		ClsPlotScrn();
		UpdateGUIState();
	}	
}

/****************************************************************************
*
*   Function:			OnSetRate() 
*	description:		When click set rate button
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnSetRate() 
{
	// TODO: Add your control notification handler code here
	m_rate_edit.GetWindowText(strTmp);
	theApp.DLL_Scan_obj[uSelected_Index].fScanRate = atof(strTmp);
	if(theApp.DLL_Scan_obj[uSelected_Index].fScanRate < 10){
		theApp.DLL_Scan_obj[uSelected_Index].fScanRate = 10;
		strTmp.Format("%4.3f",theApp.DLL_Scan_obj[uSelected_Index].fScanRate);
		m_rate_edit.SetWindowText(strTmp);
	}
	if(theApp.DLL_Scan_obj[uSelected_Index].fScanRate > 1000){
		theApp.DLL_Scan_obj[uSelected_Index].fScanRate = 1000;
		strTmp.Format("%4.3f",theApp.DLL_Scan_obj[uSelected_Index].fScanRate);
		m_rate_edit.SetWindowText(strTmp);
	}
	wErr_ret = theApp.pDLL_SetRate(&theApp.DLL_Scan_obj[uSelected_Index],&theApp.DLL_Scan_obj[uSelected_Index].fScanRate);
	//strTmp.Format("%5.3f",theApp.DLL_Scan_obj[uSelected_Index].fScanRate);
	m_rate_edit.SetWindowText(strTmp);
	WriteLogEntry("Set rate %4.3f>> %s",theApp.DLL_Scan_obj[uSelected_Index].fScanRate,theApp.pDLL_Error_Msg[wErr_ret]);
	if(wErr_ret != COMMAND_OK){
		WriteLogEntry("Set rate %4.3f>> %s",theApp.DLL_Scan_obj[uSelected_Index].fScanRate,theApp.pDLL_Error_Msg[wErr_ret]);
		WriteLogEntry("!!!All operation are invalid");
	}
	OnChComm(bCurSelChan);
	
}

/****************************************************************************
*
*   Function:			OnSetRTC()
*	description:		When click set M40x RTC button
*	input:				real time clock will be download to M40x board and force
*						M40x reboot
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnSetRTC()
{
	wErr_ret = theApp.pDLL_SetRTC(&theApp.DLL_Scan_obj[uSelected_Index]);
	WriteLogEntry("Set RTC >> %s",theApp.pDLL_Error_Msg[wErr_ret]);
	if(wErr_ret == COMMAND_OK){
		OnConnect();//disconnect it 
	}
}


/****************************************************************************
*
*   Function:			SubWndIntLock(BYTE bState)
*	description:		Enable/Disable some buttons on the dialog box
*	input:				BYTE bState
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::SubWndIntLock(BYTE bState)
{
	BYTE i;

	for(i = 0; i < 8; i++){
		if(!theApp.DLL_Scan_obj[uSelected_Index].bScanStopped){
			m_pDigiOut[i]->EnableWindow(TRUE);
		}
		else{
			m_pDigiOut[i]->EnableWindow(bState);
		}
	}
	m_start_btn.EnableWindow(bState);
	if(Context[uSelected_Index].bMODE){
		// do only in non polling mode
		if(!theApp.DLL_Scan_obj[uSelected_Index].bScanStopped){
			m_end_scan.EnableWindow(TRUE);
		}
		else{
			m_end_scan.EnableWindow(FALSE);
		}
	}
	m_init_dev.EnableWindow(bState);
	if(m_multi_chan.GetCheck()){
		m_cal_scan_check.EnableWindow(bState);
		m_multi_chan.EnableWindow(bState);
		m_num_of_chan.EnableWindow(bState);
		m_ChkExtended.EnableWindow(FALSE);
		m_BtnExScanSetup.EnableWindow(FALSE);
	}
	else{
		m_ChkExtended.EnableWindow(TRUE);
		m_num_of_chan.EnableWindow(FALSE);
		m_multi_chan.EnableWindow(FALSE);
		m_cal_scan_check.EnableWindow(FALSE);
		m_ChkExtended.EnableWindow(TRUE);		
		m_BtnExScanSetup.EnableWindow(TRUE);

	}
	m_avg_combo.EnableWindow(bState);
	m_rate_edit.EnableWindow(bState);
	m_set_rtc.EnableWindow(bState);
	m_sys_cal_btn.EnableWindow(bState);
	m_set_rate_btn.EnableWindow(bState);
	m_multi_chan.EnableWindow(bState);
	m_self_test.EnableWindow(bState);
	m_polled_radio.EnableWindow(bState);	
	m_scan_radio.EnableWindow(bState);	
	m_dac0_output.EnableWindow(FALSE);
	m_dac0_edit.EnableWindow(FALSE);
	m_dac1_output.EnableWindow(FALSE);
	m_dac1_edit.EnableWindow(FALSE);
	m_dac2_output.EnableWindow(FALSE);
	m_dac2_edit.EnableWindow(FALSE);	
	
}

/****************************************************************************
*
*   Function:			OnSelfTest() 
*	description:		When click M40x self test button
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::OnSelfTest() 
{
	// TODO: Add your control notification handler code here
	char		SelfTstMsg[4096];
	char* selfTstMsgPtr = SelfTstMsg;
	char* selfTstMsgEndPtr;
	wErr_ret = theApp.pDLL_GetSelfTestRst(&theApp.DLL_Scan_obj[uSelected_Index],SelfTstMsg);
	WriteLogEntry("Get self test >> %s",theApp.pDLL_Error_Msg[wErr_ret]);
	if(wErr_ret != COMMAND_OK) return;
	WriteLogEntry("========Self test result report ======");
	selfTstMsgEndPtr = selfTstMsgPtr + strlen(selfTstMsgPtr);
	do{
		strTmp.Format("");
		do{
			strTmp = strTmp + *selfTstMsgPtr;
			selfTstMsgPtr++;
		}while((*selfTstMsgPtr != 0x0a) & (selfTstMsgPtr < selfTstMsgEndPtr));
		WriteLogEntry(strTmp);
		selfTstMsgPtr++;		//skip CR between strings
	}while(selfTstMsgPtr < selfTstMsgEndPtr);
}

void CM40xVCDlg::OnFileExit() 
{
	// TODO: Add your command handler code here
//	OnOK();	
	OnExit();
}

void CM40xVCDlg::OnHelpAbout() 
{
	// TODO: Add your command handler code here
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
	
}


/****************************************************************************
*
*   Function:			UpDateAllDsp()
*	description:		
*	input:				
*   output:				
*	global variable:	

  
Changes 11.5.2003

  - Increase the priority of the main thread to THREAD_PRIORITY_HIGHEST before
	updating any of the controls (when a second thread is used to poll the dll 
	for new scan data) to reduce latency, after updating all the controls restore
	priority to THREAD_PRIORITY_NORMAL.
****************************************************************************/
void CM40xVCDlg::UpDateAllDsp()
{
	BYTE i,j,bSelChan,bNumOfScans;	
	if(flgUsingThreadForDataAcq)
		theApp.SetThreadPriority(THREAD_PRIORITY_HIGHEST);
	if(theApp.DLL_Scan_obj[uSelected_Index].bScanMode == SINGLE_CHAN_SCAN){
		bSelChan = GetCurChanSel();//get single channel selection
		strTmp.Format("%s",FormatVolt(theApp.DLL_Scan_volts_buff[uSelected_Index].fVolts[bSelChan][0], uSelected_Index));
		m_pChanReading[bSelChan]->SetWindowText(strTmp);
	}
	else{
		bSelChan = this->bCurSelChan;
		if(theApp.DLL_Scan_obj[uSelected_Index].bScanMode ==  MULT_CHAN_CAL_SCAN){
			strTmp.Format("%s",FormatVolt(theApp.DLL_Scan_volts_buff[uSelected_Index].fVolts[7][0], uSelected_Index));			
			m_pChanReading[7]->SetWindowText(strTmp);
		}
		for(i = 0; i < theApp.DLL_Scan_obj[uSelected_Index].bLastScanChan;i++){
			j = CvntChanID(i);
			strTmp.Format("%s",FormatVolt(theApp.DLL_Scan_volts_buff[uSelected_Index].fVolts[j][0], uSelected_Index));
			m_pChanReading[j]->SetWindowText(strTmp);
		}
	}
	strTmp.Format("%s",FormatVolt(theApp.DLL_Scan_volts_buff[uSelected_Index].fVoltsMax[bSelChan], uSelected_Index));
	m_max_dsp.SetWindowText(strTmp);
	strTmp.Format("%s",FormatVolt(theApp.DLL_Scan_volts_buff[uSelected_Index].fVoltsMin[bSelChan], uSelected_Index));
	m_min_dsp.SetWindowText(strTmp);
	strTmp.Format("%.2f",theApp.DLL_Scan_volts_buff[uSelected_Index].fEffectiveBits[bSelChan]);
	m_effective_bits.SetWindowText(strTmp);
	strTmp.Format("%s", FormatVolt(theApp.DLL_Scan_volts_buff[uSelected_Index].fVoltsMax[bSelChan] - theApp.DLL_Scan_volts_buff[uSelected_Index].fVoltsMin[bSelChan], uSelected_Index));
	m_delta_dsp.SetWindowText(strTmp);	
	strTmp.Format("%s",FormatVolt(theApp.DLL_Scan_volts_buff[uSelected_Index].fstDv[bSelChan], uSelected_Index));
	m_std_devi.SetWindowText(strTmp);
	if(theApp.DLL_Scan_obj[uSelected_Index].bScanMode == SINGLE_CHAN_SCAN){		
		bNumOfScans = theApp.DLL_Scan_obj[uSelected_Index].RevDataPoints;
	}
	else{
		if(theApp.DLL_Scan_obj[uSelected_Index].bSelChanOrNumOfChan){
			bNumOfScans = theApp.DLL_Scan_obj[uSelected_Index].RevDataPoints / theApp.DLL_Scan_obj[uSelected_Index].bSelChanOrNumOfChan;
		}
		else{
			return;		//in case divided by zero
		}
	}
	for(i = 0; i < bNumOfScans;i++){
		if(theApp.DLL_Scan_obj[uSelected_Index].bIsValidData){
			PlotOnePixel(theApp.DLL_Scan_volts_buff[uSelected_Index].fVolts[bSelChan][i]);
		}
		else{
			i = i;
		}
	}
	UpdateDigIn(theApp.DLL_Scan_obj[uSelected_Index].bDigIn[0]);
	if(theApp.DLL_Scan_obj[uSelected_Index].bScanBuffOverLapped ||
		theApp.DLL_Scan_obj[uSelected_Index].bChkSumErr ||
		theApp.DLL_Scan_obj[uSelected_Index].bADChipRegCorrupted
		){
		EnableShowError();
	}	
	strTmp.Format("Scan #: %ld",theApp.DLL_Scan_obj[uSelected_Index].ulScanCounts);
	m_scan_counts.SetWindowText(strTmp);
	if(flgUsingThreadForDataAcq)
		theApp.SetThreadPriority(THREAD_PRIORITY_NORMAL);
}

/****************************************************************************
*
*   Function:			WriteScanLogFile(int nIndex)
*	description:		Write scan data to log file
*	input:				
*   output:				
*	global variable:	
*
*		
****************************************************************************/
void CM40xVCDlg::WriteScanLogFile(UINT uIndex)
{
	ULONG i,j,k,l;
	CString myStr;
	time_t ltime;
	time( &ltime );
	if(Context[uIndex].bSaveToFile){//plain text file format output
		if( (theApp.DLL_Scan_obj[uIndex].bScanMode == EXTENDED_SCAN) || (theApp.DLL_Scan_obj[uIndex].bScanMode == EXTENDED_CAL_SCAN)){
			k=0;
			for(i=0;i<Context[uIndex].ulNumOfExScans;i++){
				fprintf(pScanDataLogFile[uIndex],"%9ld   ",i + 1+ (Context[uIndex].ulExScanCounts - Context[uIndex].ulNumOfExScans));
				if(Context[uIndex].ExtScan_AD0_Start >=0){
					for(j=Context[uIndex].ExtScan_AD0_Start;j<=(ULONG)Context[uIndex].ExtScan_AD0_End;j++){
						fprintf(pScanDataLogFile[uIndex],"%s   ",FormatVolt(Context[uIndex].fExScans[k++],uIndex));
					}
				}
				if(Context[uIndex].ExtScan_AD1_Start >=0){
					for(j=Context[uIndex].ExtScan_AD1_Start;j<=(ULONG)Context[uIndex].ExtScan_AD1_End;j++){
						fprintf(pScanDataLogFile[uIndex],"%s   ",FormatVolt(Context[uIndex].fExScans[k++],uIndex));
					}
				}
				if(Context[uIndex].ExtScan_AD6){
					fprintf(pScanDataLogFile[uIndex],"%s   ",FormatVolt(Context[uIndex].fExScans[k++],uIndex));
				}
				if(Context[uIndex].ExtScan_AD7){
					fprintf(pScanDataLogFile[uIndex],"%s   ",FormatVolt(Context[uIndex].fExScans[k++],uIndex));
				}
				fprintf(pScanDataLogFile[uIndex],"%02x\n",theApp.DLL_Scan_obj[uIndex].bDigIn[k-1]);

			}
		}
		else if(theApp.DLL_Scan_obj[uIndex].bScanMode == SINGLE_CHAN_SCAN){
			for(j = 0; j < theApp.DLL_Scan_obj[uIndex].RevDataPoints; j++){
				fprintf(pScanDataLogFile[uIndex],"%9ld   ",(unsigned long)j + (theApp.DLL_Scan_obj[uIndex].ulScanCounts - theApp.DLL_Scan_obj[uIndex].RevDataPoints));
				fprintf(pScanDataLogFile[uIndex],"%s   ",FormatVolt(theApp.DLL_Scan_volts_buff[uIndex].fVolts[theApp.DLL_Scan_obj[uIndex].bSelChanOrNumOfChan][j],uIndex));
				fprintf(pScanDataLogFile[uIndex],"%02x\n",theApp.DLL_Scan_obj[uIndex].bDigIn[j]);
			}
		}
		else{
			if(theApp.DLL_Scan_obj[uIndex].bSelChanOrNumOfChan){
				k = theApp.DLL_Scan_obj[uIndex].RevDataPoints / theApp.DLL_Scan_obj[uIndex].bSelChanOrNumOfChan;
			}
			else{
				k = theApp.DLL_Scan_obj[uIndex].RevDataPoints;
			}
			for(j = 0; j < k; j++){
				fprintf(pScanDataLogFile[uIndex],"%9ld,",(unsigned long)j + (theApp.DLL_Scan_obj[uIndex].ulScanCounts - k));
				for(i = 0; i < theApp.DLL_Scan_obj[uIndex].bSelChanOrNumOfChan; i++){
					l = CvntChanID(i);
					if((theApp.DLL_Scan_obj[uIndex].bScanMode == MULT_CHAN_CAL_SCAN) && (i== (ULONG)(theApp.DLL_Scan_obj[uIndex].bSelChanOrNumOfChan -1 )))
						l=7;
						fprintf(pScanDataLogFile[uIndex],"%s   ",FormatVolt(theApp.DLL_Scan_volts_buff[uIndex].fVolts[l][j],uIndex));
				}
				//BUG fprintf(pScanDataLogFile[uIndex],"%02x\n",theApp.DLL_Scan_obj[uIndex].bDigIn[j]);
				fprintf(pScanDataLogFile[uIndex],"%02x\n",theApp.DLL_Scan_obj[uIndex].bDigIn[j * theApp.DLL_Scan_obj[uIndex].bSelChanOrNumOfChan]); //BUGFIX
				//Note - each data point is associated with a digital input. To save disk space only the first digital input associated with the 
				//first data point is printed
			}	
		}
		return;
	}
}

/****************************************************************************
*
*   Function:			WriteLogEntry(LPCTSTR pstrFormat, ...)
*	description:		Add log information to the event list window
*						And event log file if it needs to be saved
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::WriteLogEntry(LPCTSTR pstrFormat, ...)
{
	CString strTm,str,s;
	CTime timeWrite;
	timeWrite = CTime::GetCurrentTime();
	// write the time out
	strTm = timeWrite.Format("%H:%M:%S ");
	// format and write the data we were given
	va_list args;
	va_start(args, pstrFormat);
	str.FormatV(pstrFormat, args);
	strTm = strTm + str;
	m_evt_log_wnd.AddString(strTm);	
	m_evt_log_wnd.SetCurSel((m_evt_log_wnd.GetCount() - 1));
	m_evt_log_wnd.UpdateWindow();
	ulTotalLogLines++;
	if(Context[uSelected_Index].bSaveLog){
		if(!pEventLogFile[uSelected_Index]){
			s.Format("%s",m_ip);
			s.Replace('.','_');
			s += ".log";
			pEventLogFile[uSelected_Index] = fopen(s, "a+");
		}
		fprintf(pEventLogFile[uSelected_Index],"%s \n", strTm);
	}else{
		if(pEventLogFile[uSelected_Index]) fclose(pEventLogFile[uSelected_Index]);
	}

}

/****************************************************************************
*
*   Function:		SaveScanDataDlg
*	description:	Check if we need to save scan data into file
*						
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::SaveScanDataDlg()
{

	time_t t;
	char tm_str[128];
	CString sTemp, sFormatStr;
	int nVoltColWidth,i,j, nNumOfCols;
	if(!m_save_log_file.GetCheck()){
		pScanDataLogFile[uSelected_Index] = NULL;
		Context[uSelected_Index].bSaveToFile =0;
		return;
	}		
	sTemp = Context[uSelected_Index].sIP;
	sTemp.Replace('.','_');
	sprintf(LogFileName,"%s_%s.txt",sTemp,(CTime::GetCurrentTime()).Format("%m_%d_%Y_%H_%M_%S"));	
	//Filename format - ip address('.' replaced by '_')_date and time('_' delimited).txt
	bIsTextLogFile = 1;
	pScanDataLogFile[uSelected_Index] = fopen(LogFileName, "w");
	if(!pScanDataLogFile[uSelected_Index]){
		MessageBox("Failed to open log file","ERROR",MB_OK);
		pScanDataLogFile[uSelected_Index] = NULL;
	}
	else{
		Context[uSelected_Index].bSaveToFile = 1;
		nNumOfCols = 0;
		time(&t);
		strcpy(tm_str,ctime(&t));
		//.......fprintf(pScanDataLogFile[uSelected_Index],"Created on: %s",ctime(&t));				
//		nVoltColWidth = (FormatVolt(0,uSelected_Index)).GetLength() + 3;
		nVoltColWidth = strlen(FormatVolt(0,uSelected_Index)) + 3;

		if(   (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == EXTENDED_SCAN) || (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == EXTENDED_CAL_SCAN)  )   {
			//EXTENDED SCAN, EXTENDED CAL SCAN
			fprintf(pScanDataLogFile[uSelected_Index],"Scan Rate: %4.3f\n",theApp.DLL_Scan_obj[uSelected_Index].fMultiChanScanRate);
			nNumOfCols++;
			if(Context[uSelected_Index].bExtCalScan){
				fprintf(pScanDataLogFile[uSelected_Index],"Extended calibration scan\n");
			}
			else{
				fprintf(pScanDataLogFile[uSelected_Index],"Extended scan\n");
			}
			fprintf(pScanDataLogFile[uSelected_Index],"Scan ####   ");
			if(Context[uSelected_Index].ExtScan_AD0_Start >=0){
				for(i=Context[uSelected_Index].ExtScan_AD0_Start;i<=Context[uSelected_Index].ExtScan_AD0_End;i++){
					sTemp.Format("AD0_%d",i);//column name
					sFormatStr.Format("%%-%ds",nVoltColWidth);//prepare format str
					fprintf(pScanDataLogFile[uSelected_Index],sFormatStr,sTemp);
					nNumOfCols++;
				}

			}
			if(Context[uSelected_Index].ExtScan_AD1_Start >=0){
				for(i=Context[uSelected_Index].ExtScan_AD1_Start;i<=Context[uSelected_Index].ExtScan_AD1_End;i++){
					sTemp.Format("AD1_%d",i);//column name
					sFormatStr.Format("%%-%ds",nVoltColWidth);//prepare format str
					fprintf(pScanDataLogFile[uSelected_Index],sFormatStr,sTemp);
					nNumOfCols++;
				}
			}
			if(Context[uSelected_Index].ExtScan_AD6){
				sTemp.Format("AD6");//column name
				sFormatStr.Format("%%-%ds",nVoltColWidth);//prepare format str
				fprintf(pScanDataLogFile[uSelected_Index],sFormatStr,sTemp);
				nNumOfCols++;
			}
			if(Context[uSelected_Index].ExtScan_AD7){
				sTemp.Format("AD7");//column name
				sFormatStr.Format("%%-%ds",nVoltColWidth);//prepare format str
				fprintf(pScanDataLogFile[uSelected_Index],sFormatStr,sTemp);
				nNumOfCols++;
			}
			fprintf(pScanDataLogFile[uSelected_Index],"Dig Input\n");
			nNumOfCols++;
		}
		else if(theApp.DLL_Scan_obj[uSelected_Index].bScanMode == SINGLE_CHAN_SCAN){
			//SINGLE CHAN SCAN
			fprintf(pScanDataLogFile[uSelected_Index],"Scan Rate: %4.3f\n",theApp.DLL_Scan_obj[uSelected_Index].fScanRate);
			fprintf(pScanDataLogFile[uSelected_Index],"Single channel scan\n");
			fprintf(pScanDataLogFile[uSelected_Index],"Scan ####   ");
			// Write column names
			sTemp.Format("AD%d",theApp.DLL_Scan_obj[uSelected_Index].bSelChanOrNumOfChan);//column name
			sFormatStr.Format("%%-%dsDig Input\n",nVoltColWidth);//prepare format str			
			fprintf(pScanDataLogFile[uSelected_Index],sFormatStr,sTemp);		
			nNumOfCols = 3;
		}
		else{
			//MULT CHAN SCAN, MULT CHAN CAL SCAN
			fprintf(pScanDataLogFile[uSelected_Index],"Scan Rate: %4.3f\n",theApp.DLL_Scan_obj[uSelected_Index].fMultiChanScanRate);
			if(theApp.DLL_Scan_obj[uSelected_Index].bScanMode == MULT_CHAN_CAL_SCAN){
				fprintf(pScanDataLogFile[uSelected_Index],"Multi Channel with Calibration \n");
			}
			else{
				fprintf(pScanDataLogFile[uSelected_Index],"Multi Channel \n");
			}
			// Write columns names
			fprintf(pScanDataLogFile[uSelected_Index],"Scan ####   ");
			nNumOfCols++;
			for(i=0;i<theApp.DLL_Scan_obj[uSelected_Index].bSelChanOrNumOfChan;i++){
				if( (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == MULT_CHAN_CAL_SCAN) && ( i == theApp.DLL_Scan_obj[uSelected_Index].bSelChanOrNumOfChan)){
					//in multi channel calib scanning the last channel is always AD 7
					j = 7;
				}
				else{
					j = CvntChanID(i);
				}
				sTemp.Format("AD%d",j);//column name
				sFormatStr.Format("%%-%ds",nVoltColWidth);//prepare format str
				fprintf(pScanDataLogFile[uSelected_Index],sFormatStr,sTemp);
				nNumOfCols++;
			}
			fprintf(pScanDataLogFile[uSelected_Index],"Dig Input\n");
			nNumOfCols++;			
		}
		//Draw ============= separator between col names and col values
		for(i=0;i<nNumOfCols * nVoltColWidth;i++){
			fprintf(pScanDataLogFile[uSelected_Index],"=");
		}
		fprintf(pScanDataLogFile[uSelected_Index],"\n");
	}
	
}

/********************************************************************************
Function:	OnTimerProc(
				HWND  hwnd,	// handle of window for timer messages
				UINT  uMsg,	// WM_TIMER message
				UINT  idEvent,	// timer identifier
				DWORD  dwTime 	// current system time
			}

Input:		HWND  hwnd,	// handle of window for timer messages
			UINT  uMsg,	// WM_TIMER message
			UINT  idEvent,	// timer identifier
			DWORD  dwTime 	// current system time

Return:		


Desc:		
		Handles two timers. UpdateClockID timer (every 1sec) updates clock
		at the bottom of dialog. TimerID timer (every 10ms) calls GetNewScanData
		to get new scan data for all the indices.

Changes:
		
*************************************************************************************/




void CALLBACK CM40xVCDlg::OnTimerProc(
    HWND  hwnd,	// handle of window for timer messages
    UINT  uMsg,	// WM_TIMER message
    UINT  idEvent,	// timer identifier
    DWORD  dwTime 	// current system time
   )
{
	static UINT uSecTick = 0;
	UINT i;
	RETURN_CODE RetCode;
	
	if(idEvent == theApp.pdlg->UpdateClockID){
		theApp.pdlg->m_Time.SetWindowText((CTime::GetCurrentTime()).Format("%H:%M::%S"));
		// for all indices in polled mode, call Pub_SetDigOut every 5 seconds to check if still connected
		// to M401
		uSecTick = (uSecTick + 1) % 5;
		if(uSecTick == 0){
			//5 Second interval detected
			for(i=0;i<MAX_M401;i++){
				if(Context[i].bIsConnected){
					//Connected
					
					if( i == uSelected_Index){
						//currently selected index
						RetCode = theApp.pDLL_GetLastError(&theApp.DLL_Scan_obj[i]);
						if(RetCode == NOT_CONNECTED){
							theApp.pdlg->m_ExVoltDlg.ShowWindow(SW_HIDE);
							theApp.pdlg->WriteLogEntry("Got Disconnected");
							theApp.pdlg->OnConnect();
						}
					}
					else{
						RetCode = theApp.pDLL_GetLastError(&theApp.DLL_Scan_obj[i]);
						if(RetCode == NOT_CONNECTED){
								Context[i].sEvtLogMsg += (CTime::GetCurrentTime()).Format("%H:%M:%S");
								Context[i].sEvtLogMsg += " Got Disconnected \n";
								Context[i].bIsConnected = FALSE;
						}
					}				
					
				}
			}
		}
	}

	if(idEvent == theApp.pdlg->TimerID){		
		theApp.pdlg->ReadNewScanData();
	}
	
}


/****************************************************************************
*
*   Function:			SaveAllSettings()
*	description:		When exit, save all settings
*						
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CM40xVCDlg::SaveAllSettings()
{
	int nFileLen, nFilePathLen;
	char pcExecPath[1000];
	char pcExecFilename[100];
	_snprintf(pcExecFilename,100,"%s.exe",theApp.m_pszExeName);
	if(GetModuleFileName(GetModuleHandle(pcExecFilename),pcExecPath,1000)){
		nFileLen = strlen(pcExecFilename);
		nFilePathLen = strlen(pcExecPath);
		pcExecPath[nFilePathLen - nFileLen] = '\0';
		strcat(pcExecPath,"M40x.cfg");
		pConfigFile = fopen(pcExecPath, "w");
	}
	else{
		pConfigFile = fopen("M40x.cfg", "w");
	}	
	if(!pConfigFile){
		pConfigFile = NULL;
		return;
	}
	else{
		for(int i=0; i<MAX_M401;i++){			
			fprintf(pConfigFile,"IP Address : %s\n",Context[i].sIP);
			fprintf(pConfigFile,"Subnet mask: %s\n",Context[i].sSubnetMask);
			fprintf(pConfigFile,"GateWay IP : %s\n",Context[i].sGateway);
			fprintf(pConfigFile,"DHCP tmout : %d\n",Context[i].bDhcpTmout);
			fprintf(pConfigFile,"Scan Avg   : %d\n",Context[i].bAvg );
			fprintf(pConfigFile,"Digital out: %d\n",Context[i].bDigitalOut);			
			fprintf(pConfigFile,"Polled mode: %d\n",(Context[i].bMODE == 1));
			fprintf(pConfigFile,"Multi  chan: %d\n",((theApp.DLL_Scan_obj[i].bScanMode == MULT_CHAN_SCAN) || (theApp.DLL_Scan_obj[i].bScanMode == MULT_CHAN_CAL_SCAN)));
			fprintf(pConfigFile,"Cal.   scan: %d\n",(theApp.DLL_Scan_obj[i].bScanMode == MULT_CHAN_CAL_SCAN));
			fprintf(pConfigFile,"Number chan: %d\n",Context[i].bNumOfChan );
			fprintf(pConfigFile,"AC/DC  mode: %d\n",Context[i].bGraphAC_DC);
			fprintf(pConfigFile,"Disp   chan: %d\n",Context[i].bChanSel);
			fprintf(pConfigFile,"Volts/Div  : %d\n",Context[i].bGraphVerticalScale);			
			fprintf(pConfigFile,"Scan Rate  : %f\n",Context[i].fScanRate);
			fprintf(pConfigFile,"GraphTimeBase  :1\n");	// New-unused field to make this cfg file
			// format compatible with visual basic file format.			
			fprintf(pConfigFile,"EX_AD0_START: %d\n",Context[i].ExtScan_AD0_Start);
			fprintf(pConfigFile,"EX_AD0_END: %d\n",Context[i].ExtScan_AD0_End);
			fprintf(pConfigFile,"EX_AD1_START: %d\n",Context[i].ExtScan_AD1_Start);
			fprintf(pConfigFile,"EX_AD1_END: %d\n",Context[i].ExtScan_AD1_End);
			fprintf(pConfigFile,"EX_AD6: %d\n",Context[i].ExtScan_AD6);
			fprintf(pConfigFile,"EX_AD7: %d\n",Context[i].ExtScan_AD7);
			fprintf(pConfigFile,"EX_CAL_SCAN: %d\n",Context[i].bExtCalScan);
			fprintf(pConfigFile,"EX_MUX_INVERT: %d\n",Context[i].bMuxInverted);
			fprintf(pConfigFile,"\n");		// a new line demarkation between two indices
		}
		fprintf(pConfigFile,"\nNETWORK_EVENT_THREAD_PRIORITY :%d",bNetworkEventThreadPriority);
		fprintf(pConfigFile,"\nNETWORK_POLL_THREAD_PRIORITY :%d",bNetworkPollThreadPriority);
		fputs("\n",pConfigFile);
		for(i=0;i<nNumExtraSetting;i++)			
			fputs(pExtraSetting[i],pConfigFile);	

		fclose(pConfigFile);
		
		
	}
}

/****************************************************************************
*
*   Function:			LoadAllSettings()
*	description:		At startup load all settings from M40x.cfg
*						
*	input:				
*   output:				TRUE(loading OK) FALSE(loading failed)
*	global variable:	
****************************************************************************/
BOOL CM40xVCDlg::LoadAllSettings()
{
	int i,nFilePathLen, nFileLen;
	int nIndexPos;
	char pTmp[100];
	//char pStr[1000];
	char pcExecPath[1000];
	char pcExecFilename[100];
	nNumExtraSetting =0;
	_snprintf(pcExecFilename,100,"%s.exe",theApp.m_pszExeName);
	if(GetModuleFileName(GetModuleHandle(pcExecFilename),pcExecPath,1000)){
		//AfxMessageBox(pcExecPath);
		nFileLen = strlen(pcExecFilename);
		nFilePathLen = strlen(pcExecPath);
		pcExecPath[nFilePathLen - nFileLen] = '\0'; //retain only the path
		strcat(pcExecPath,"M40x.cfg");	//app path + M40x.cfg
		pConfigFile = fopen(pcExecPath, "r");
	}
	else{
		pConfigFile = fopen("M40x.cfg", "r");

	}
	nIndexPos = 0;
	if(!pConfigFile){
		pConfigFile = NULL;
		return FALSE;
	}
	else
	{
		for(i=0;i<MAX_M401;i++){

			//IP ADDRESS
			nIndexPos = GetNextIndexPos(nIndexPos,pConfigFile,pTmp);
			if(nIndexPos == -1)
				return FALSE;		//Cannot find the start of next index (IP Address : missing)
			Context[i].sIP = pTmp;
			Context[i].sIP.TrimLeft();
			Context[i].sIP.TrimRight();

			// SUBNET ADDRESS
			if(GetSettingValue(nIndexPos,pConfigFile,"Subnet mask:",pTmp)){				
				Context[i].sSubnetMask = pTmp;				
				Context[i].sSubnetMask.TrimLeft();
				Context[i].sSubnetMask.TrimRight();
			}

			//GateWay IP
			if(GetSettingValue(nIndexPos,pConfigFile,"GateWay IP :",pTmp)){	
				Context[i].sGateway = pTmp;
				Context[i].sGateway.TrimLeft();
				Context[i].sGateway.TrimRight();				
			}

			//DHCP
			if(GetSettingValue(nIndexPos,pConfigFile,"DHCP tmout :",pTmp)){	
				Context[i].bDhcpTmout = atoi(pTmp);				
			}

			//Scan Avg   :
			if(GetSettingValue(nIndexPos,pConfigFile,"Scan Avg   :",pTmp)){	
				Context[i].bAvg = atoi(pTmp);
				if(Context[i].bAvg == 0)
					Context[i].bAvg =1;
				if(Context[i].bAvg > 32)
					Context[i].bAvg = 32;			
			}

			//Digital out:
			if(GetSettingValue(nIndexPos,pConfigFile,"Digital out:",pTmp)){	
				Context[i].bDigitalOut = atoi(pTmp);				
			}

			//Polled mode:
			if(GetSettingValue(nIndexPos,pConfigFile,"Polled mode:",pTmp)){	
				if(atoi(pTmp)){
					Context[i].bMODE = 1; //polled					
				}
				else{
					Context[i].bMODE = 0;

				}
				
			}
			//Multi  chan:
			if(GetSettingValue(nIndexPos,pConfigFile,"Multi  chan:",pTmp)){	
				if(atoi(pTmp)){
					theApp.DLL_Scan_obj[i].bScanMode = MULT_CHAN_SCAN;
				}			
				//Cal.   scan:
				if(GetSettingValue(nIndexPos,pConfigFile,"Cal.   scan:",pTmp)){	
					if(atoi(pTmp)){
						theApp.DLL_Scan_obj[i].bScanMode = MULT_CHAN_CAL_SCAN;
					}
				}			
			}
			else{
				theApp.DLL_Scan_obj[i].bScanMode = SINGLE_CHAN_SCAN;			
			}
			//Number chan:
			if(GetSettingValue(nIndexPos,pConfigFile,"Number chan:",pTmp)){	
				Context[i].bNumOfChan = atoi(pTmp);
				if(Context[i].bNumOfChan == 0)
					Context[i].bNumOfChan = 1;
				if(Context[i].bNumOfChan > 8)
					Context[i].bNumOfChan = 8;
			}
			//AC/DC  mode:
			if(GetSettingValue(nIndexPos,pConfigFile,"AC/DC  mode:",pTmp)){	
				Context[i].bGraphAC_DC = atoi(pTmp);

			}

			//Disp   chan:
			if(GetSettingValue(nIndexPos,pConfigFile,"Disp   chan:",pTmp)){
				Context[i].bChanSel = atoi(pTmp);
				Context[i].bGraphChanSel = Context[i].bChanSel;
			}

			//Volts/Div  :  Vertical scale of graph
			if(GetSettingValue(nIndexPos,pConfigFile,"Volts/Div  :",pTmp)){
				Context[i].bGraphVerticalScale = atoi(pTmp);
			}

			//Scan Rate  :
			if(GetSettingValue(nIndexPos,pConfigFile,"Scan Rate  :",pTmp)){
				Context[i].fScanRate = atof(pTmp);
			}

			//GraphTimeBase  : Horizontal scale of graph
			if(GetSettingValue(nIndexPos,pConfigFile,"GraphTimeBase  :",pTmp)){
				//Context[i].bGraphVerticalScale = atoi(pTmp);
			}
			if(GetSettingValue(nIndexPos,pConfigFile,"EX_AD0_START:",pTmp)){
				Context[i].ExtScan_AD0_Start = atol(pTmp);
			}
			if(GetSettingValue(nIndexPos,pConfigFile,"EX_AD0_END:",pTmp)){
				Context[i].ExtScan_AD0_End = atol(pTmp);
			}
			if(GetSettingValue(nIndexPos,pConfigFile,"EX_AD1_START:",pTmp)){
				Context[i].ExtScan_AD1_Start = atol(pTmp);
			}
			if(GetSettingValue(nIndexPos,pConfigFile,"EX_AD1_END:",pTmp)){
				Context[i].ExtScan_AD1_End = atol(pTmp);
			}
			if(GetSettingValue(nIndexPos,pConfigFile,"EX_AD6:",pTmp)){
				Context[i].ExtScan_AD6 = atoi(pTmp);
			}
			if(GetSettingValue(nIndexPos,pConfigFile,"EX_AD7:",pTmp)){
				Context[i].ExtScan_AD7 = atoi(pTmp);
			}
			if(GetSettingValue(nIndexPos,pConfigFile,"EX_CAL_SCAN:",pTmp)){
				Context[i].bExtCalScan = atoi(pTmp);
			}
			if(GetSettingValue(nIndexPos,pConfigFile,"EX_MUX_INVERT:",pTmp)){
				Context[i].bMuxInverted = atoi(pTmp);
			}			
		}
		if(GetSettingValue(nIndexPos,pConfigFile,"NETWORK_EVENT_THREAD_PRIORITY :",pTmp))
			bNetworkEventThreadPriority = atoi(pTmp);

		if(GetSettingValue(nIndexPos,pConfigFile,"NETWORK_POLL_THREAD_PRIORITY :",pTmp))
			bNetworkPollThreadPriority = atoi(pTmp);
		
		LoadExtraSetting(pConfigFile);

	}
	fclose(pConfigFile);
	return TRUE;
}

void CM40xVCDlg::OnOK()
{
}

void CM40xVCDlg::OnExit()
{
	//make sure all M401 have stopped scanning and disconnected
	RETURN_CODE DLLCallRet;	
	WriteLogEntry(" Wait...closing all connection");
	for(int i=0;i<MAX_M401;i++){
		do{
			DLLCallRet = theApp.pDLL_EndScan(&theApp.DLL_Scan_obj[i]);		
		}
		while(DLLCallRet == PENDING);	
		theApp.pDLL_CloseConnection(&theApp.DLL_Scan_obj[i]);		
	}
	//07.02.03
	if(flgUsingThreadForDataAcq){
		flgThreadRun = FALSE;	//Stop thread gracefully
		Sleep(200);		//allow thread to get slice and exit;
		if(pDataAcqThread != NULL)
			TerminateThread(pDataAcqThread->m_hThread,0);	//force thread to terminate if
			//if did not stop by checking flag
	}
	CDialog::OnOK();
}

void CM40xVCDlg::OnEditAvgCombo()
{
#if 0
	m_avg_combo.GetWindowText(strTmp);
	bChanScanAvg = atoi(strTmp);
	OnSelchangeAvgCombo();
#endif
}


/****************************************************************************
*
*   Function:			CloseOpenFile()
*	description:		used when data from M401 needs to be inserted 
						into a file - opens and closes the file
*						
*	input:				
*   output:
*	global variable:	
****************************************************************************/
void CM40xVCDlg::CloseOpenFile()
{
	time_t t;
	char	tm_str[128];
//	if(bIsTextLogFile){//plain text file format output
		if(pScanDataLogFile[uSelected_Index]){
			time(&t);
			strcpy(tm_str,ctime(&t));
			//........fprintf(pScanDataLogFile[uSelected_Index],"Scan ending time:%s",ctime(&t));
			fclose(pScanDataLogFile[uSelected_Index]);
		}
//	}
	/*
	else{
		
		LOGGING TO DATA BASE NOT YET SUPPORTED
		if(m_pDatabase != NULL){
			if(m_pRecordSet) m_pRecordSet->Close();
			if(m_pRecordSet != NULL){
				delete m_pRecordSet;
				m_pRecordSet = NULL;
			}
			if(m_pTableDef != NULL){
			m_pTableDef->Close();
				delete m_pTableDef;
				m_pTableDef = NULL;
			}
			if ((m_pDatabase)->IsOpen())	m_pDatabase->Close();
		}
	
	}
	*/
}

void CM40xVCDlg::OnHelp() 
{
	// TODO: Add your control notification handler code here
#ifdef _DEBUG
	


#endif
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	char sAppName[100];;
	_snprintf(sAppName,100,"%s.exe",theApp.m_pszExeName);
	SetDlgItemText(IDC_APP_VERSION,GetDllVer(sAppName));
	SetDlgItemText(IDC_DLL_VERSION,GetDllVer("M40x.dll"));		
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

CString CAboutDlg::GetDllVer(char *sModule)
{

	CString sVersion="?,?,?,?";
	char *pVerInfo=NULL;	
	VS_FIXEDFILEINFO *pVS_Struct=NULL;
	DWORD dwHandle=0,dwVerInfoSize=0;
	UINT uLen=0;	
	dwVerInfoSize=GetFileVersionInfoSize(sModule,&dwHandle);
	if(dwVerInfoSize){
		pVerInfo = new char[dwVerInfoSize];	
		if(pVerInfo != NULL){			
			if(GetFileVersionInfo(sModule,NULL,dwVerInfoSize,pVerInfo)){										
				if(VerQueryValue(pVerInfo,"\\",(LPVOID *)(&pVS_Struct),&uLen)){					
					if(uLen  && pVS_Struct != NULL){						
						sVersion.Format("[%d,%d,%d,%d]",(pVS_Struct->dwFileVersionMS >> 16) &0xffff ,pVS_Struct->dwFileVersionMS & 0xffff,(pVS_Struct->dwFileVersionLS >> 16) &0xffff ,pVS_Struct->dwFileVersionLS & 0xffff);						
					}
				}
			}
		}
	}
	if(pVerInfo != NULL)
		delete [] pVerInfo;
	return sVersion;

}




/**********************************************************
Function:	Save_Index_Context

Input: None

Return: None


Desc: 
		Must be called after user selects a different index to
		operate on. Saves current user selections to be restored
		when user selects this index to view in future.

Changes:
		05.09.2003 
			Created

**********************************************************/

void CM40xVCDlg::Save_Index_Context()
{
	CString sTmp;
	//save log messages
	Context[uSelected_Index].sEvtLogMsg = "";
	for(int i=0;i<m_evt_log_wnd.GetCount();i++){
		m_evt_log_wnd.GetText(i,sTmp);
		Context[uSelected_Index].sEvtLogMsg+=sTmp+"\n";		
	}
	//average		
	m_avg_combo.GetWindowText(sTmp);
	Context[uSelected_Index].bAvg = atoi(sTmp);	
	//number of channels	
	m_num_of_chan.GetWindowText(sTmp);
	Context[uSelected_Index].bNumOfChan = atoi(sTmp);
	//currently selected channel
	Context[uSelected_Index].bChanSel = bCurSelChan;
	//y axis scale 	
	Context[uSelected_Index].bGraphVerticalScale = m_volt_div_combo.GetCurSel();
	//rate in text box
	m_rate_edit.GetWindowText(sTmp);	
	Context[uSelected_Index].fScanRate = atof(sTmp);	
	//channel for plotting graph	
	Context[uSelected_Index].bGraphChanSel = m_chan_sel.GetCurSel();
	//ac - dc, bIsAC var stores the AC/DC	
    Context[uSelected_Index].bGraphAC_DC = m_dc_ac_sel.GetCurSel();    
	// save scan to file
	Context[uSelected_Index].bSaveToFile = (m_save_log_file.GetCheck() == 1);	
	if(m_polled_radio.GetCheck())
		// in polled mode
		Context[uSelected_Index].bMODE=1;
	else{
		// In one the scan modes	
		Context[uSelected_Index].bMODE=0;
	}
	//Digital Output
	Context[uSelected_Index].bDigitalOut = bLastDigOut;

	if(m_event_log_save_checked.GetCheck())
		Context[uSelected_Index].bSaveLog = 1;
	else
		Context[uSelected_Index].bSaveLog = 0;

	
	
}

void CM40xVCDlg::OnEditchangeIpAddressCombo() 
{
	// TODO: Add your control notification handler code here
	
	
	
}

/**********************************************************
Function:	Check_IP

Input:		s - IP address in combo box; sResult - IP address 
			formatted as dotted decimal if function returns 
			TRUE	

Return: 
		 TRUE - Valid IP address entered, sResult contains
		 IP address as dotted decimal


Desc: 
		 Removes "index = " and extra space right and left of s.
		 Checks if entered IP is valid, contains 3 dots and number
		 between dots is between 0-255.		

Changes:
		05.13.2003
			- Error IP address with a 0 digit (10.0.0.1) was incorrectly
			  interpreted as invalid [FIXED]
		
**********************************************************/

BOOLEAN CM40xVCDlg::Check_IP(CString s,CString &sResult)
{
  int nIndex,nTemp,nDotCount,nNumDigs;
  CString sIP;
  nIndex = s.Find('=');
  sIP=s;
  if(nIndex != -1){
	  nIndex++;
	  sIP=s.Right(s.GetLength() - nIndex);
  }

  sIP.TrimLeft();
  sIP.TrimRight();
  
  nDotCount =0;
  // remove space inbetween and check all characters are digits
  for(nIndex = 0;nIndex<sIP.GetLength();nIndex++){
	  if(sIP[nIndex] == ' ')
		  sIP.Delete(nIndex);
	  else{
		  
		  if(!(sIP[nIndex] >='0' && sIP[nIndex] <='9') && (sIP[nIndex] !='.')){
			  Wrong_IP_Entered();
			  return FALSE;	//
		  }
	  }
  }

  //check if in dotted decimal	and in range  
  nTemp=0;
  nNumDigs=-1; //how many digits before a .
  for(nIndex = 0;nIndex<sIP.GetLength();nIndex++){
	  if(sIP[nIndex] == '.'){
		  if((nNumDigs+1)==nIndex){
			  //no digit before a dot
			  Wrong_IP_Entered();
			  return FALSE;
		  }
		  nNumDigs=nIndex;
		  nTemp = 0;
		  nDotCount++;
	  }
	  else{
		 nTemp = nTemp*10 + sIP[nIndex] - '0';
		 if(nTemp > 255){
			  Wrong_IP_Entered();
			  return FALSE;

		 }

	  }
  }

// if no digit after last dot
  if((nNumDigs +1 ) == nIndex){
	  Wrong_IP_Entered();
	  return FALSE;

  }

//If IP address does not contain 3 dots invalid
  if(nDotCount != 3){	  
	  Wrong_IP_Entered();
	  return FALSE;
  }

  //valid IP address entered
  sResult = sIP; 
  sIP.Format("%d = %s",nIP_Index,sResult);
  m_ip_address_combo.DeleteString(nIP_Index);
  m_ip_address_combo.InsertString(nIP_Index,sIP);
  return TRUE;


}

/*******************************************************************************************************
Function:	OnSelchangeIpAddressCombo()

Input:		None

Return:		None


Desc:		Message handler when user changes current index
			(change from IP address combo). Stores new index
			nIP_Index field, saves context of current index
			and restores context of chosen index. 
Changes:

 -  11.5.2004


The second thread (see UINT CM40xVCDlg::ThreadProc(LPVOID pParam) )must acquire
the mutex before it can read or update the new scan data likewise the main thread
must acquire the mutex before switching indices, the mutext ensures these two 
operations don't overlap causing a crash.A deadlock will occur in the following situation:
the second thread acquires the mutex, reads new scan data from the dll, and is in the process
of updating controls on the main dialog(Note: if a thread other than the main thread thread
updates a MFC control an update message is inserted into message queue and the thread blocks
till the main thread dispatches and acknowledge the message) at this instant if user attempts to 
switches indices the main application thread will block (mutex held by the other thread),
the second thread cannot finish the update and release the mutex because it is waiting for
MFC update acknowledgement from the main thread! This is avoided by running the message queue
for a while so that the other thread can finish updating and release the mutex when the main thread
fails to acquire the mutex after blocking for 100ms
********************************************************************************************************/


void CM40xVCDlg::OnSelchangeIpAddressCombo() 
{
	// TODO: Add your control notification handler code here
	
	CSingleLock Lock(pMutex);	
	if(flgUsingThreadForDataAcq){		
		m_ip_address_combo.EnableWindow(FALSE);
		if(!Lock.Lock(100)){
			do{
				flgWaitForIndexSwitch = TRUE;
				theApp.PumpMessage();
				Sleep(10);
			}
			while(!Lock.Lock(10));				
		}
		m_ip_address_combo.EnableWindow();	
	}
	
	nIP_Index = m_ip_address_combo.GetCurSel();
	// latch on to the currently selected index. This will be used when
	Save_Index_Context();
	uSelected_Index = nIP_Index;
	Restore_Index_Context();

	if(flgUsingThreadForDataAcq){
		Lock.Unlock();
		flgWaitForIndexSwitch = FALSE;
	}
}


/**********************************************************
Function:	Wrong_IP_Entered()

Input:		None

Return:		None


Desc:		Displays error message when invalid IP address is 
			entered.
		

Changes:
		
**********************************************************/


void CM40xVCDlg::Wrong_IP_Entered()
{
	CString sIP;
	AfxMessageBox("IP address invalid, valid ip address has format ###.###.###.###, where # is a digit and 0>=### <=255");
	sIP.Format("%d= 0.0.0.0",nIP_Index);
	m_ip_address_combo.DeleteString(nIP_Index);
	m_ip_address_combo.InsertString(nIP_Index,sIP);
	m_ip_address_combo.SetCurSel(nIP_Index);
}






/**********************************************************
Function:	Restore_Index_Context()

Input:		None	

Return:		None


Desc:		Restores context of selected index, must be called after
			prev index's context is saved. 
			Changes m_ip 
			Clears event log list and fills it with event logs for 
			selected index
			Changes averages
			Changes number of channels
			Changes selected channel
			Changes Y axis scale
			Changes X axis scale
			Changes Rate
			Changes graph AC/DC combo
			Changes graph - selected channel
			Changes
			Changes save log to file check box state
			Changes GUI controls for Polled, Single chan scan, Multi chan scan,
			Multi chan cal scan
			Changes digital output
			Changes save event log check box state.
			Changes state of GUI controls depending on connected/disconnected to M401
			Changes error check boxes (checksum error, data missing, overflow)

Changes:
		
**********************************************************/


void CM40xVCDlg::UpdateGUIState()
{
	BYTE i,j;
	CMenu *pMenu;
	CString strTmp;
	/*****************************************************
				DISABLE ALL CONTROLS
	*****************************************************/
	DisableShowError();	
	pMenu = this->GetMenu();
	if(pMenu != NULL){
		pMenu->EnableMenuItem(ID_CONFIG_CONFIGM40X, MF_BYCOMMAND | MF_GRAYED);
		pMenu->EnableMenuItem(ID_FILE_RTCHOSTTIMEDIFF, MF_BYCOMMAND | MF_GRAYED);
	}
	//CLEAR DISPLAY OF ALL CHANNELS
	m_read_v0.SetWindowText("");
	m_read_v1.SetWindowText("");
	m_read_v6.SetWindowText("");
	m_read_v7.SetWindowText("");
	m_avg_combo.EnableWindow(FALSE);
	m_rate_edit.EnableWindow(FALSE);
	m_set_rtc.EnableWindow(FALSE);
	m_sys_cal_btn.EnableWindow(FALSE);
	m_set_rate_btn.EnableWindow(FALSE);
	m_multi_chan.EnableWindow(FALSE);
	m_self_test.EnableWindow(FALSE);
	m_polled_radio.EnableWindow(FALSE);	
	m_scan_radio.EnableWindow(FALSE);	
	m_dac0_output.EnableWindow(FALSE);
	m_dac0_edit.EnableWindow(FALSE);
	m_dac1_output.EnableWindow(FALSE);
	m_dac1_edit.EnableWindow(FALSE);
	m_dac2_output.EnableWindow(FALSE);
	m_dac2_edit.EnableWindow(FALSE);
	m_sec_p_div.EnableWindow(FALSE);
	m_cal_scan_check.EnableWindow(FALSE);
	m_chan_sel.EnableWindow(FALSE);
	m_ChkExtended.EnableWindow(FALSE);
	m_connect.EnableWindow(FALSE);
	m_dc_ac_sel.EnableWindow(FALSE);
	m_delta_dsp.EnableWindow(FALSE);
	m_effective_bits.EnableWindow(FALSE);
	m_end_scan.EnableWindow(FALSE);
	m_event_log_save_checked.EnableWindow(FALSE);
	m_evt_log_wnd.EnableWindow(FALSE);
	m_ip_address_combo.EnableWindow(FALSE);
	m_max_dsp.EnableWindow(FALSE);
	m_min_dsp.EnableWindow(FALSE);
	m_num_of_chan.EnableWindow(FALSE);
	m_Show_Error.EnableWindow(FALSE);
	m_start_btn.EnableWindow(FALSE);
	m_std_devi.EnableWindow(FALSE);
	m_volt_div_combo.EnableWindow(FALSE);
	m_save_log_file.EnableWindow(FALSE);
	m_BtnExScanSetup.EnableWindow(FALSE);
	m_init_dev.EnableWindow(FALSE);
	m_BtnResetMaxMin.EnableWindow(FALSE);
	m_ExVoltDlg.ShowWindow(SW_HIDE);
	m_polled_radio.SetCheck(0);
	m_scan_radio.SetCheck(0);
	m_multi_chan.SetCheck(0);
	m_cal_scan_check.SetCheck(0);
	m_ChkExtended.SetCheck(0);

	for(i=0;i<8;i++){
		m_pChanReading[i]->EnableWindow(FALSE);
		m_pChanSel[i]->EnableWindow(FALSE);
		m_pDigiOut[i]->EnableWindow(FALSE);
	}

	if(!Context[uSelected_Index].bIsConnected){
		//INDEX NOT CONNECTED		
		m_evt_log_wnd.EnableWindow(TRUE);
		m_connect.SetWindowText("&Connect");
		m_connect.EnableWindow(TRUE);
		m_ip_address_combo.EnableWindow(TRUE);		
	}
	else{
		//INDEX CONNECTED
		m_connect.SetWindowText("&Disconnect");
		m_connect.EnableWindow(TRUE);
		m_ip_address_combo.EnableWindow(TRUE);
		m_evt_log_wnd.EnableWindow(TRUE);		
		m_self_test.EnableWindow(TRUE);
		for(i=0;i<8;i++){
			m_pDigiOut[i]->EnableWindow(TRUE);
			if( bLastDigOut & (1 << i) ){
				m_pDigiOut[i]->SetCheck(1);
			}
			else{
				m_pDigiOut[i]->SetCheck(0);

			}
		}	
		if(theApp.DLL_Scan_obj[uSelected_Index].bScanStopped){
			//NOT SCANNING
			if(pMenu != NULL){
				pMenu->EnableMenuItem(ID_CONFIG_CONFIGM40X, MF_BYCOMMAND | MF_ENABLED);
				pMenu->EnableMenuItem(ID_FILE_RTCHOSTTIMEDIFF, MF_BYCOMMAND | MF_ENABLED);
			}
			m_save_log_file.EnableWindow(TRUE);
			m_set_rtc.EnableWindow(TRUE);
			m_rate_edit.EnableWindow(TRUE);
			m_set_rate_btn.EnableWindow(TRUE);
			m_init_dev.EnableWindow(TRUE);
			m_start_btn.EnableWindow(TRUE);
			m_sys_cal_btn.EnableWindow(TRUE);				
			m_event_log_save_checked.EnableWindow(TRUE);
			m_polled_radio.EnableWindow(TRUE);
			m_scan_radio.EnableWindow(TRUE);
			m_pChanSel[0]->EnableWindow(TRUE);
			m_pChanReading[0]->EnableWindow(TRUE);
			m_pChanSel[1]->EnableWindow(TRUE);
			m_pChanReading[1]->EnableWindow(TRUE);
			m_pChanSel[6]->EnableWindow(TRUE);
			m_pChanReading[6]->EnableWindow(TRUE);
			m_pChanSel[7]->EnableWindow(TRUE);
			m_pChanReading[7]->EnableWindow(TRUE);		
			if(Context[uSelected_Index].bMODE == 1){
				//POLLED MODE,
				m_start_btn.SetWindowText("&Get Conversion");
				m_polled_radio.SetCheck(1);
				OnChComm(bCurSelChan & 0x07);				
			}
			else{
				//SCAN MODE
				m_start_btn.SetWindowText("&Start Scan");
				m_scan_radio.SetCheck(1);			
				m_avg_combo.EnableWindow(TRUE);						
				if(theApp.DLL_Scan_obj[uSelected_Index].bScanMode == SINGLE_CHAN_SCAN){				
					m_multi_chan.EnableWindow(TRUE);
					m_BtnExScanSetup.EnableWindow(TRUE);
					m_ChkExtended.EnableWindow(TRUE);
					m_pChanSel[0]->EnableWindow(TRUE);				
					m_pChanSel[1]->EnableWindow(TRUE);				
					m_pChanSel[6]->EnableWindow(TRUE);				
					m_pChanSel[7]->EnableWindow(TRUE);
				}			
				else if((theApp.DLL_Scan_obj[uSelected_Index].bScanMode == MULT_CHAN_SCAN) || (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == MULT_CHAN_CAL_SCAN)){
					m_pChanSel[0]->EnableWindow(FALSE);				
					m_pChanSel[1]->EnableWindow(FALSE);				
					m_pChanSel[6]->EnableWindow(FALSE);				
					m_pChanSel[7]->EnableWindow(FALSE);					
					m_multi_chan.EnableWindow(TRUE);
					m_multi_chan.SetCheck(1);
					m_cal_scan_check.EnableWindow(TRUE);
					m_num_of_chan.EnableWindow(TRUE);				
					if(theApp.DLL_Scan_obj[uSelected_Index].bScanMode == MULT_CHAN_CAL_SCAN){
						m_cal_scan_check.SetCheck(1);				
					}
				}
				else{
					//EXTENDED SCAN
					m_pChanSel[0]->EnableWindow(FALSE);				
					m_pChanSel[1]->EnableWindow(FALSE);				
					m_pChanSel[6]->EnableWindow(FALSE);				
					m_pChanSel[7]->EnableWindow(FALSE);			
					m_BtnExScanSetup.EnableWindow(TRUE);
					m_ChkExtended.EnableWindow(TRUE);
					m_ChkExtended.SetCheck(1);
				}
				OnChComm(bCurSelChan & 0x07);				
			}
		}
		else{
			//SCANNING
			m_end_scan.EnableWindow(TRUE);
			m_effective_bits.EnableWindow(TRUE);
			m_max_dsp.EnableWindow(TRUE);
			m_min_dsp.EnableWindow(TRUE);			
			m_delta_dsp.EnableWindow(TRUE);			
			m_BtnResetMaxMin.EnableWindow(TRUE);
			m_scan_radio.SetCheck(1);
			m_pChanSel[0]->SetCheck(0);
			m_pChanSel[1]->SetCheck(0);
			m_pChanSel[2]->SetCheck(0);
			m_pChanSel[3]->SetCheck(0);
			if( (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == EXTENDED_SCAN) || (theApp.DLL_Scan_obj[uSelected_Index].bScanMode == EXTENDED_CAL_SCAN) ){
				//enable only selected channels
				m_ChkExtended.SetCheck(1);
				if(Context[uSelected_Index].ExtScan_AD0_Start >= 0){
					m_pChanSel[0]->EnableWindow(TRUE);
					m_pChanReading[0]->EnableWindow(TRUE);
				}
				if(Context[uSelected_Index].ExtScan_AD1_Start >= 0){
					m_pChanSel[1]->EnableWindow(TRUE);
					m_pChanReading[1]->EnableWindow(TRUE);
				}
				if(Context[uSelected_Index].ExtScan_AD6){
					m_pChanSel[6]->EnableWindow(TRUE);
					m_pChanReading[6]->EnableWindow(TRUE);
				}
				if(Context[uSelected_Index].ExtScan_AD7){
					m_pChanSel[7]->EnableWindow(TRUE);
					m_pChanReading[7]->EnableWindow(TRUE);		
				}
				m_ExVoltDlg.ShowWindow(SW_SHOW);
				OnChComm(bCurSelChan & 0x07);
				strTmp.Format("Scan rate:%4.3f",theApp.DLL_Scan_obj[uSelected_Index].fMultiChanScanRate);
				m_scan_rate.SetWindowText(strTmp);

			}
			else{
				m_std_devi.EnableWindow(TRUE);
				m_dc_ac_sel.EnableWindow(TRUE);
				m_sec_p_div.EnableWindow(TRUE);
				m_volt_div_combo.EnableWindow(TRUE);				

				if(theApp.DLL_Scan_obj[uSelected_Index].bScanMode == MULT_CHAN_SCAN){
					//Enable selected channels
					for(i=0;i<theApp.DLL_Scan_obj[uSelected_Index].bSelChanOrNumOfChan;i++){
						j=CvntChanID(i);
						m_pChanSel[j]->EnableWindow(TRUE);
						m_pChanReading[j]->EnableWindow(TRUE);						
						m_multi_chan.SetCheck(1);
						m_cal_scan_check.SetCheck(0);

					}
				}
				else if(theApp.DLL_Scan_obj[uSelected_Index].bScanMode == MULT_CHAN_CAL_SCAN){
					m_pChanSel[7]->EnableWindow(TRUE);
					m_pChanReading[7]->EnableWindow(TRUE);
					for(i=0;i<theApp.DLL_Scan_obj[uSelected_Index].bSelChanOrNumOfChan-1;i++){
						j=CvntChanID(i);
						m_pChanSel[j]->EnableWindow(TRUE);
						m_pChanReading[j]->EnableWindow(TRUE);						
						m_multi_chan.SetCheck(1);
						m_cal_scan_check.SetCheck(1);

					}
				}
				else{
					//SINGLE CHANNEL SCANNING 
					m_pChanSel[0]->EnableWindow(TRUE);
					m_pChanReading[0]->EnableWindow(TRUE);
					m_pChanSel[1]->EnableWindow(TRUE);
					m_pChanReading[1]->EnableWindow(TRUE);
					m_pChanSel[6]->EnableWindow(TRUE);
					m_pChanReading[6]->EnableWindow(TRUE);
					m_pChanSel[7]->EnableWindow(TRUE);
					m_pChanReading[7]->EnableWindow(TRUE);					

				}
				OnChComm(bCurSelChan & 0x07);
				UpdateLabel();
			}			
			if(theApp.DLL_Scan_obj[uSelected_Index].bChkSumErr || theApp.DLL_Scan_obj[uSelected_Index].bScanBuffOverLapped || theApp.DLL_Scan_obj[uSelected_Index].bADChipRegCorrupted){
				EnableShowError();
			}
		}			
		
	}
	/*
	if(Context[uSelected_Index].bChanSel == 0)
		m_sel_ch0.SetCheck(1);

	else if(Context[uSelected_Index].bChanSel == 1)
		m_sel_ch1.SetCheck(1);

	else if(Context[uSelected_Index].bChanSel == 6)
		m_sel_ch6.SetCheck(1);

	else
		m_sel_ch7.SetCheck(1);	
	//MODE
	// enable all channels, if multi channel scan then disable
	if(Context[uSelected_Index].bMODE == 0){
		//in polled mode
		m_polled_radio.SetCheck(1);
		m_scan_radio.SetCheck(0);
		m_multi_chan.SetCheck(0);
		m_cal_scan_check.SetCheck(0);			
		m_multi_chan.EnableWindow(FALSE);
		m_cal_scan_check.EnableWindow(FALSE);
		m_start_btn.SetWindowText("&Get Conversion");
		m_sel_ch0.EnableWindow(TRUE);
		m_sel_ch1.EnableWindow(TRUE);
		m_sel_ch6.EnableWindow(TRUE);
		m_sel_ch7.EnableWindow(TRUE);
		m_end_scan.EnableWindow(FALSE);
		
	}
	else{
		 // in Single Chan, Multi Chan or Cal Scan Mode
		m_start_btn.SetWindowText("&Start Scan");
		m_polled_radio.SetCheck(0);
		m_scan_radio.SetCheck(1);
		m_multi_chan.EnableWindow(TRUE);
		m_cal_scan_check.EnableWindow(TRUE);		
		if(Context[uSelected_Index].bMODE == 1){
			// in Single Chan Mode
			m_multi_chan.SetCheck(0);
			m_cal_scan_check.SetCheck(0);
			m_sel_ch0.EnableWindow(TRUE);
			m_sel_ch1.EnableWindow(TRUE);
			m_sel_ch6.EnableWindow(TRUE);
			m_sel_ch7.EnableWindow(TRUE);

		}
		if(Context[uSelected_Index].bMODE == 2){
			// in Multi chan mode
			m_multi_chan.SetCheck(1);
			m_cal_scan_check.SetCheck(0);
			m_sel_ch0.EnableWindow(FALSE);
			m_sel_ch1.EnableWindow(FALSE);
			m_sel_ch6.EnableWindow(FALSE);
			m_sel_ch7.EnableWindow(FALSE);						
		}
		if(Context[uSelected_Index].bMODE == 3){
			// Cal Scan Mode
			m_multi_chan.SetCheck(1);
			m_cal_scan_check.SetCheck(1);
			m_sel_ch0.EnableWindow(FALSE);
			m_sel_ch1.EnableWindow(FALSE);
			m_sel_ch6.EnableWindow(FALSE);
			m_sel_ch7.EnableWindow(FALSE);
			
		}
	}
	//Check checkbox if error occurred
	if(theApp.DLL_Scan_obj[uSelected_Index].bChkSumErr ||
		theApp.DLL_Scan_obj[uSelected_Index].bScanBuffOverLapped ||
		theApp.DLL_Scan_obj[uSelected_Index].bADChipRegCorrupted)
		EnableShowError();
	else
		DisableShowError();
	*/
}

void CM40xVCDlg::Restore_Index_Context()
{
	CString sTmp;
	int nLen,i;	
	//IP ADDRESS
	m_ip = Context[uSelected_Index].sIP;
	m_ip_address_combo.DeleteString(uSelected_Index);
	sTmp.Format("%d = %s",uSelected_Index,m_ip);
	m_ip_address_combo.InsertString(uSelected_Index,sTmp);	
	m_ip_address_combo.SetCurSel(uSelected_Index);
	//EVENT LOGS
	nLen = Context[uSelected_Index].sEvtLogMsg.GetLength();
	//remove all items
	m_evt_log_wnd.ResetContent();
	sTmp = "";
	for(i=0;i<nLen;i++){
		if(Context[uSelected_Index].sEvtLogMsg[i] == '\n'){
			//put this line in list box
			m_evt_log_wnd.AddString(sTmp);
			sTmp = "";
		}
		else{
			// keep accum chars till we get a '\n'
			sTmp += Context[uSelected_Index].sEvtLogMsg[i];
		}		
	}
	// AVERAGE	
	sTmp.Format("%d",Context[uSelected_Index].bAvg);
	m_avg_combo.SetWindowText(sTmp);			
	// NUMBER OF CHANNELS	
	sTmp.Format("%d",Context[uSelected_Index].bNumOfChan);
	m_num_of_chan.SetWindowText(sTmp);	
	//UN CHECK SELECTED CHANNEL	
	m_sel_ch0.SetCheck(0);
	m_sel_ch1.SetCheck(0);
	m_sel_ch6.SetCheck(0);
	m_sel_ch7.SetCheck(0);
	//GRAPH	Y AXIS SCALE
	m_volt_div_combo.SetCurSel(Context[uSelected_Index].bGraphVerticalScale);
	ClsPlotScrn();
	//RATE
	sTmp.Format("%.2f",Context[uSelected_Index].fScanRate);
	m_rate_edit.SetWindowText(sTmp);
	UpdateLabel(); //adjust secs per div	
	//AC DC
	m_dc_ac_sel.SetCurSel(Context[uSelected_Index].bGraphAC_DC);
	bIsAC = (m_dc_ac_sel.GetCurSel() == 1);
	//GRAPH CHANNEL;
	m_chan_sel.SetCurSel(Context[uSelected_Index].bGraphChanSel);	
	// SAVE SCAN TO FILE
	m_save_log_file.SetCheck((Context[uSelected_Index].bSaveToFile == 1));
	// DIGITAL OUTPUT	
	bLastDigOut = Context[uSelected_Index].bDigitalOut;	
	BYTE bMask =1;
	//LOG EVENTS ????
	if(Context[uSelected_Index].bSaveLog)
		m_event_log_save_checked.SetCheck(1);
	else
		m_event_log_save_checked.SetCheck(0);
	bCurSelChan = Context[uSelected_Index].bChanSel;
	UpdateGUIState();	

}



/**********************************************************
Function:	Init_Index_Context()

Input:		None

Return:		None	


Desc:		Initializes context of each index with default
			values. These values will be used if M40x.cfg
			is not found or is corrupted.
		

Changes:
		
**********************************************************/

void CM40xVCDlg::Init_Index_Context()
{
 int i;

 for(i = 0;i<MAX_M401;i++){
	 Context[i].bAvg =1;
	 Context[i].bChanSel =0;
	 Context[i].bGraphAC_DC =1;
	 Context[i].bGraphChanSel =0;
	 Context[i].bGraphVerticalScale =0;
	 Context[i].bIsConnected  =0;
	 Context[i].bMODE =0;
	 Context[i].bNumOfChan=1;
	 Context[i].bSaveToFile=0;
	 Context[i].fScanRate = 100.0;
	 Context[i].sEvtLogMsg = "";
	 Context[i].sIP = "";	 
	 Context[i].bSaveLog =0;
     Context[i].ExtScan_AD0_Start = -1;
     Context[i].ExtScan_AD1_Start = -1;
     Context[i].ExtScan_AD6 = 0;
     Context[i].ExtScan_AD7 = 0;
     Context[i].bExtCalScan = 0;
     Context[i].bMuxInverted =0;
	 theApp.DLL_Scan_obj[i].bScanMode = SINGLE_CHAN_SCAN;
 }

}



/**********************************************************
Function:	int ParseLine(char *pLine, char *pToken)

Input:	pLine - line which needs to be searched; 
        
		pToken - word to be searched

Return: 
		-1 if failed to find pToken in pLine

		>=0	index into pLine where pToken ends


Desc: 
		Searches pLine for pToken.		

Changes:
		
**********************************************************/

int CM40xVCDlg::ParseLine(char *pLine, char *pToken)
{
	int i,nPos,nLen;
	nPos = -1;
	char pWord[100];
	nLen = strlen(pToken);
	if(nLen >=100)
		return nPos;
	for(i=0;pLine[i]!='\0';i++){
		memcpy(pWord,&pLine[i],nLen);
		pWord[nLen] = '\0';
		if(strcmp(pWord,pToken)==0){
			nPos = i+nLen;
			break;
		}
	}
	return nPos;

}




/**********************************************************
Function:	Get_IP_Params()

Input:		None

Return:		None


Desc:		Updates s
		

Changes:
		
**********************************************************/

void CM40xVCDlg::Get_IP_Params()
{
	char		SelfTstMsg[4096];
	int pos,i;
	wErr_ret = theApp.pDLL_GetSelfTestRst(&theApp.DLL_Scan_obj[uSelected_Index],SelfTstMsg);	
	if(wErr_ret != COMMAND_OK) return;
	
	pos = ParseLine(SelfTstMsg,"Net mask.");
	if(pos == -1)
		return;

	Context[uSelected_Index].sSubnetMask = "";
	for(i=0;SelfTstMsg[pos+i]!='\n';i++)
		Context[uSelected_Index].sSubnetMask += SelfTstMsg[pos +i];

	pos = ParseLine(SelfTstMsg,"Gateway IP.");
	if(pos == -1)
		return;

	Context[uSelected_Index].sGateway = "";
	for(i=0;SelfTstMsg[pos+i]!='\n';i++)
		Context[uSelected_Index].sGateway += SelfTstMsg[pos +i];

	pos = ParseLine(SelfTstMsg,"DHCP timeout.");
	if(pos == -1)
		return;
	Context[uSelected_Index].bDhcpTmout = atoi(&SelfTstMsg[pos]);	

}

void CM40xVCDlg::OnEvtLogSave() 
{
	// TODO: Add your control notification handler code here
	if(m_event_log_save_checked.GetCheck()){
		Context[uSelected_Index].bSaveLog = 1;
		pEventLogFile[uSelected_Index]= NULL;
	}
	else{
		Context[uSelected_Index].bSaveLog = 0;
	}
	
}

/**********************************************************
Function:	EnableShowError()	
	
Input:		

Return:		


Desc:		Enable controls which indicate an error, while 
			scanning. "Scan Error" in red is printed in
			text box.
			Called by UpdateAllDsp when it encounters a
			scan error.	

Changes:
			06.05.2003 
				- created
		
**********************************************************/

void CM40xVCDlg::EnableShowError()
{	
	m_Scan_Error.EnableWindow(TRUE);
	m_Scan_Error.SetWindowText("Scan Error");
	m_Show_Error.EnableWindow(TRUE);
	
	
	

}


/**********************************************************
Function:	DisableShowError()

Input:		

Return:		


Desc:		Disable controls which indicate a scan error.
			Called at start of scan, get conv in polled mode
			and connect/disconnect.	

Changes:
			06.05.2003 
				- created
		
**********************************************************/
void CM40xVCDlg::DisableShowError()
{
	m_Scan_Error.EnableWindow(FALSE);
	m_Scan_Error.SetWindowText("");
	m_Show_Error.EnableWindow(FALSE);
}

/**********************************************************
Function:	OnShowError() 

Input:		

Return:		


Desc:		Event handler for "Show Error" button.
			Shows dialog box with checkboxes for 
			buffer overflow, checksum error, data missing 
		

Changes:
			06.05.2003 
				- created
**********************************************************/

void CM40xVCDlg::OnShowError() 
{
	// TODO: Add your control notification handler code here
	CScan_Error_Dlg dlg;	
	dlg.DoModal();
}

void CM40xVCDlg::OnInHouseOnly() 
{
	// TODO: Add your control notification handler code here
	
	
}









/**********************************************************
Function:	ThreadProc(LPVOID pParam)

Input:		pParam

Return:		UINT


Desc:		
			Call ReadNewScanData repeatedly to update index structures
			with new scan data and to process them. Sleep for 30 ms 
			before calling ReadNewScanData again. This will make
			sure that other threads with the same priority are given
			adequate CPU cycles.
			

Changes:

  11.5.2003
		
		  Before reading new scan data and updating the controls this thread
		  must acquire the mutex.If flqWaitForContextSwitch is TRUE wait.

		
**********************************************************/
UINT CM40xVCDlg::ThreadProc(LPVOID pParam)
{	
	BOOLEAN flgRet;	
	CSingleLock Lock(theApp.pdlg->pMutex);	    
	while(theApp.pdlg->flgThreadRun){
		if(!theApp.pdlg->flgWaitForIndexSwitch){		
			Lock.Lock();
			flgRet=theApp.pdlg->ReadNewScanData();
			Lock.Unlock();
			if(!flgRet)
				Sleep(30);
		}
		else
			Sleep(20);
	}

	return 0;

}










/**********************************************************
Function:	CheckForKeyword

Input:		

Return:		


Desc:		
			Scans every line of callback.cfg file looking
			for pKeyword. If found returns TRUE or else 
			returns FALSE
		

Changes:
-11.24.2003
 Keyword is commented only if the comment token, "//", is before the keyword

		
**********************************************************/


//07.02.2003
BOOLEAN CM40xVCDlg::CheckForKeyword(const char * pKeyword)
{
	FILE *fptr;
	char buffer[500];	
	char *pCommentPtr, *pKeywordPtr ;
	fptr = fopen("callback.cfg","r");
	if(fptr != NULL){
		
		while(fgets(buffer,500,fptr)!=NULL){
			pKeywordPtr = strstr(_strupr(buffer),pKeyword);
			if(pKeywordPtr != NULL){
				pCommentPtr = strstr(_strupr(buffer),"//");
				if((pCommentPtr != NULL) && (pCommentPtr < pKeywordPtr))
					continue;				
				fclose(fptr);
				return TRUE; // a line contains the keyword
			}
		}

		fclose(fptr);
	}	
	return FALSE;

}



/****************************************************************************
*
*   Function:			OnBlockRecv()
*	description:		Call back function from M40xDLL, It is called 
						whenever a data block is received in scan mode
						pM40xDll->DLL_Scan_volts_buff[] is available with data
						the delay in this function will delay the OnReceive()
						process which gets the data from the TCP/IP socket
*	input:				
*   output:				
*	global variable:	
****************************************************************************/
void CALLBACK EXPORT CM40xVCDlg::OnBlockRecv(void)
{
	UINT i;
    
	for(i=0;i<MAX_M401;i++){
		if(theApp.DLL_Scan_obj[i].bDataReady){			
			theApp.DLL_Scan_obj[i].bDataReady =0;
			if( (theApp.DLL_Scan_obj[i].RevDataPoints == 0) && (theApp.DLL_Scan_obj[i].bScanStopped)  ){
				if(i == uSelected_Index){
					theApp.pdlg->WriteLogEntry("Got disconnected while scanning");
					theApp.pdlg->OnConnect();
				}
				else{
					//Log "lost connection while scanning" into index's event log buffer					
					Context[i].sEvtLogMsg += (CTime::GetCurrentTime()).Format("%H:%M:%S");
					Context[i].sEvtLogMsg += " Got disconnected while scanning\n";
					Context[i].bIsConnected = FALSE;
				}				
			}
			else{
				if(Context[i].bSaveToFile)
					theApp.pdlg->WriteScanLogFile(i);
				if(i == uSelected_Index)
					theApp.pdlg->UpDateAllDsp();	//update GUI only when uSelected_Index has new scan data
			}
		}		
	}
	
	// Toggle as long as a M401 is scanning
	if(theApp.pdlg->bIconToggle){//flash the icon 
		theApp.pdlg->SetIcon(theApp.pdlg->m_hIconGray,FALSE);
		theApp.pdlg->bIconToggle = 0;
	}
	else{
		theApp.pdlg->SetIcon(theApp.pdlg->m_hIconBlue,FALSE);
		theApp.pdlg->bIconToggle = 1;
	}
}












/****************************************************************************************
Function:	CM40xVCDlg::ReadNewScanData()

Input:		

Return:		TRUE if dll has new scan data for any of the active
			indices.

			FALSE otherwise.


Desc:		
	This function is responsible for data acquisition for all the active indices.
			
			1. Set uNumPointsToRead to 0 and call Pub_ReadScanData to 
			   get the  number of new scan data points available
			   

			2. If call to PubReadScanData succeeded and uNumPointsToRead
			   indicates there is new scan data try reading all the available
			   scan data in the next call to PubReadScanData.If SSCAN_OBJ::
			   RevDataPoints indicates there may still be unread scan data
			   points try to read them in subsequent calls to Pub_ReadScanData.

			   Typically a single call to PubReadScanData after getting the
			   number of new scan data points is enough to get all the new 
			   scan data points. However, if there has been considerable 
			   delay since the last time scan data point was read there
			   may more scan data than can be transferred by a single call
			   via SSCAN_OBJ, SSCAN_VOLTS_BUFF structs of this index.

		

Changes:
		
******************************************************************************************/

//read extended scands from the dll

BOOLEAN CM40xVCDlg::ReadNewExScanData(UINT uIndex)
{
	UINT uiNumScansToReturn, uiNumScansReturned, uiNumScansInBuff;
	double fVoltsMax, fVoltsMin, fEffBits;
	UINT i,k;
	LONG j;	
	CString strTmp;
	//check number of scans in the dll
	uiNumScansToReturn = 0;
	if(!theApp.pDLL_ReadExScanDataDbl(&theApp.DLL_Scan_obj[uIndex],Context[uIndex].fExScans, Context[uIndex].bExDigInp,uiNumScansToReturn,&uiNumScansReturned,&uiNumScansInBuff)){
		if(theApp.DLL_Scan_obj[uIndex].bScanStopped){
			if(uIndex == uSelected_Index){
				m_ExVoltDlg.ShowWindow(SW_HIDE);
				WriteLogEntry("Got disconnected while scanning");
				OnConnect();
			}
			else{
				//Log "lost connection while scanning" into index's event log buffer					
				Context[uIndex].sEvtLogMsg += (CTime::GetCurrentTime()).Format("%H:%M:%S");
				Context[uIndex].sEvtLogMsg += "Got disconnected while scanning\n";
				Context[uIndex].bIsConnected = FALSE;
			}
		}
		return FALSE;
	}
	if(!uiNumScansInBuff){
		return FALSE;	//no scans
	}
	else if(uiNumScansInBuff > 10){
		uiNumScansToReturn = 10; //buffer can fit max of 10 scans when all the subchannels are selected
	}
	else{
		uiNumScansToReturn = uiNumScansInBuff;
	}
	if(!theApp.pDLL_ReadExScanDataDbl(&theApp.DLL_Scan_obj[uIndex],Context[uIndex].fExScans,Context[uIndex].bExDigInp,uiNumScansToReturn,&uiNumScansReturned,&uiNumScansInBuff)){
		return FALSE;	
	}
	Context[uIndex].ulNumOfExScans = uiNumScansReturned;
	// note - application needs to keep track of scan number 
	Context[uIndex].ulExScanCounts += Context[uIndex].ulNumOfExScans;
	if(uIndex == uSelected_Index){		
		k=0;
		for(i=0;i<Context[uIndex].ulNumOfExScans;i++){
			if(Context[uIndex].ExtScan_AD0_Start >=0){
				for(j=Context[uIndex].ExtScan_AD0_Start;j<=Context[uIndex].ExtScan_AD0_End;j++){
					m_ExVoltDlg.m_SAD0[j].SetWindowText(FormatVolt(Context[uIndex].fExScans[k],uIndex));
					if( (j == (bLastDigOut & 0x0F)) && (bCurSelChan == 0)){
						m_read_v0.SetWindowText(FormatVolt(Context[uIndex].fExScans[k],uIndex));
					}
					k++;
				}
			}
			if(Context[uIndex].ExtScan_AD1_Start >=0){
				for(j=Context[uIndex].ExtScan_AD1_Start;j<=Context[uIndex].ExtScan_AD1_End;j++){
					m_ExVoltDlg.m_SAD1[j].SetWindowText(FormatVolt(Context[uIndex].fExScans[k],uIndex));
					if( (j == (bLastDigOut & 0x0F)) && (bCurSelChan == 1)){
						m_read_v1.SetWindowText(FormatVolt(Context[uIndex].fExScans[k],uIndex));
					}
					k++;
				}
			}			
			if(Context[uIndex].ExtScan_AD6){															
				strTmp.Format("%9.7f",Context[uIndex].fExScans[k]);
				m_ExVoltDlg.m_SAD6.SetWindowText(strTmp);
				//....m_ExVoltDlg.m_SAD6.SetWindowText(FormatVolt(Context[uIndex].fExScans[k],uIndex));								
				if(bCurSelChan == 6){
					m_read_v6.SetWindowText(FormatVolt(Context[uIndex].fExScans[k],uIndex));
				}				
				k++;
			}
			if(Context[uIndex].ExtScan_AD7){				
				strTmp.Format("%9.7f",Context[uIndex].fExScans[k]);
				m_ExVoltDlg.m_SAD7.SetWindowText(strTmp);
				//....m_ExVoltDlg.m_SAD7.SetWindowText(FormatVolt(Context[uIndex].fExScans[k],uIndex));
				if(bCurSelChan == 7){
					m_read_v7.SetWindowText(FormatVolt(Context[uIndex].fExScans[k],uIndex));
				}
				k++;
			}			
			UpdateDigIn(Context[uIndex].bExDigInp[k-1]);
		}	

		if(theApp.pDLL_GetMinMaxEffBits(&theApp.DLL_Scan_obj[uIndex],&fVoltsMax,&fVoltsMin,&fEffBits)){
			strTmp.Format("%s",FormatVolt(fVoltsMax, uIndex));
			m_max_dsp.SetWindowText(strTmp);
			strTmp.Format("%s",FormatVolt(fVoltsMin, uIndex));
			m_min_dsp.SetWindowText(strTmp);
			strTmp.Format("%.2f",fEffBits, uIndex);
			m_effective_bits.SetWindowText(strTmp);
			strTmp.Format("%s", FormatVolt(fVoltsMax - fVoltsMin, uIndex));
			m_delta_dsp.SetWindowText(strTmp);	
		}
	}
	strTmp.Format("Scan #: %ld",Context[uIndex].ulExScanCounts);
	m_scan_counts.SetWindowText(strTmp);
	if(Context[uIndex].bSaveToFile){
		WriteScanLogFile(uIndex);  //log to file,	
	}
	return TRUE;

}

BOOLEAN CM40xVCDlg::ReadNewScanData()
{
	UINT i, uNumPointsToRead;
	CString s;	
	BOOLEAN flgNewScanData;
	flgNewScanData = FALSE;
	for(i=0;i<MAX_M401;i++){
		// check ith index
		// find out how many scan data points are available to be read.			
		if(theApp.DLL_Scan_obj[i].bScanStopped)
			continue;	
		uNumPointsToRead = 0;
		if((theApp.DLL_Scan_obj[i].bScanMode == EXTENDED_SCAN) || (theApp.DLL_Scan_obj[i].bScanMode == EXTENDED_CAL_SCAN)){			
			ReadNewExScanData(i);
		}
		else{
			if(theApp.pDLL_ReadScanData(&theApp.DLL_Scan_obj[i], &uNumPointsToRead)){
				//success reading number of available scan data points
				if(uNumPointsToRead){
					// there is scan data points available try to read all			
					// the available scan data points
					flgNewScanData = TRUE;	//got data don't sleep till there is data in dll
					do{	
						if(theApp.pDLL_ReadScanData(&theApp.DLL_Scan_obj[i], &uNumPointsToRead)){					
							//SSCAN_OBJ, SSCAN_VOLTS_BUFF structures of ith index are 
							// now updated with SSCAN_OBJ::RevDataPoints number of new
							// scan data points.							
							if(	i == uSelected_Index){			
								// if i th is index selected for viewing																
								theApp.pdlg->UpDateAllDsp();	//update GUI only when uSelected_Index has new scan data	
							}
							if(Context[i].bSaveToFile)
								theApp.pdlg->WriteScanLogFile(i);  //log to file,	
							uNumPointsToRead -= theApp.DLL_Scan_obj[i].RevDataPoints;			
						}
						else{				
							//In multichannel scan it is quite possible that the dll has an incomplete scan
							//mode when Pub_ReadScanData is called. In this case dll does not remove
							// scan data from its internal buffer, it returns FALSE. Application must 
							// call later when the complete scan is available.
							break;
						}					
						Sleep(10);
					}while(uNumPointsToRead); //while still unread scan data points							
				}					
			}			
			else{
				if(theApp.DLL_Scan_obj->bScanStopped){
					if(i == uSelected_Index){
						WriteLogEntry("Got disconnected while scanning");
						OnConnect();
					}
					else{						
						//Log "lost connection while scanning" into index's event log buffer					
						Context[i].sEvtLogMsg += (CTime::GetCurrentTime()).Format("%H:%M:%S");
						Context[i].sEvtLogMsg += "Lost Connection while scanning\n";
						Context[i].bIsConnected = FALSE;
					}					
				}
			}
		}			
	}
	return flgNewScanData;
}


void CM40xVCDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default

	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}


/****************************************************************************************
Function:	CM40xVCDlg::EnterPressedInComboBox()

Input:		None

Return:		None

Desc:			
			Called by CComboEdit, a demo app defined MFC class derived from CEdit.
			A CComboEdit object is used to subclass the edit box control in the 
			combo box containing the ip address. Framework routes the WM_KEYDOWN messages 
	        to this object which calls this function if the "enter" key is pressed.

			Pressing the enter key indicates user has updated the ip address and intends
			to preserve it in the combo box for future use. Ip adress is also preserved
			in the list box when the user click "connect" after entering ip address 
			irrespective of whether user has clicked enter .
			

  
Created:	07.30.03


Changes:
		
******************************************************************************************/


void CM40xVCDlg::EnterPressedInComboBox()
{
  CString sIP,s;
  theApp.pdlg->m_ip_address_combo.GetWindowText(s); //Get value entered by user
  if(theApp.pdlg->Check_IP(s, sIP)){
	   Context[uSelected_Index].sIP = sIP;
	   s.Format("%d = %s",uSelected_Index,sIP);
	   theApp.pdlg->m_ip_address_combo.DeleteString(uSelected_Index);
	   theApp.pdlg->m_ip_address_combo.InsertString(uSelected_Index, s);	
  }


}



/****************************************************************************************
Function:	CM40xVCDlg::GetNextIndexPos(int nPrevIndexPos, FILE *fptr, CString& sIP)

Input:		
			nPrevIndexPos - start of the prev index or prev IP Address:
			Tag. For index 0 nPrevIndexPos =0. Calling function must
			cache the value returned by this function, for use in
			subsequent calls. 

			fptr - Pointer to the open cfg file.

			sIP	 - if return value is +ve then this contains the IP address
				   address of the M401 last connected to this index	


Return:		
			-1 Cannot find start of index

			>=0 File pointer pos of next index

Desc:		
			All the config setting of an index is found betweeen two IP Address:
			tags or an IP Address tag and end of file if the the index is 
			the last one. This
			

  
Created:	07.30.03


Changes:
		
******************************************************************************************/

int CM40xVCDlg::GetNextIndexPos(int nPrevIndexPos, FILE *fptr, char *pIP)
{
	int nIndexPos;
	char pStr[500], *pTag;
	nIndexPos = -1;
	fseek(fptr, nPrevIndexPos, 0); //move file ptr well within the current index
	// and start searching for the next index.
	// IP Address
	do{
		if(fgets(pStr,500,pConfigFile)==NULL)
			return nIndexPos; //there was a error return or end of file
		pTag = strstr(_strupr(pStr),"IP ADDRESS :");

	}while(pTag == NULL); //if IP Adress tag not found keep searching till we get EOF
	pTag += strlen("IP Address :");
	strcpy(pIP, pTag);
    nIndexPos = ftell(fptr);        
	return nIndexPos;


}

/****************************************************************************************
Function:	CM40xVCDlg::GetSettingValue(int nIndexPos, FILE *fptr, CString sTag, CString &sValue)

Input:		

			nIndexPos - Starting position of this index	in the file

			fptr - pointer to the open file

			pSearchTag - Tag to be searched for

			pValue - if config setting is found this contains the setting
			value in ASCII


Return:		
			TRUE - if config setting is found

			FALSE - otherwise

Desc:			
			

  
Created:	07.30.03


Changes:
		
******************************************************************************************/


BOOLEAN CM40xVCDlg::GetSettingValue(int nIndexPos, FILE *fptr,const char *pSTag, char *pValue)
{
	char pStr[500], *pTag, pSearchTag[100];
	BOOLEAN flgCrossedThisIndex = FALSE;

	fseek(fptr,nIndexPos,0); //Set file pointer to the begining of this index.
	strcpy(pSearchTag,pSTag);

	do{

		if(fgets(pStr,500,pConfigFile)==NULL){
			flgCrossedThisIndex = TRUE;		//hit EOF so crossed over this index
		}
		else{
			pTag = strstr(_strupr(pStr),"IP ADDRESS :");
			if(pTag == NULL){
				//Still withing the index
				pTag = strstr(strupr(pStr), strupr((char *)pSearchTag));
				if(pTag != NULL){
					//Found setting 
					pTag += strlen(pSearchTag); //position the pointer to end of tag/ begining of value
					strcpy(pValue, pTag);
					return TRUE;
				}

			}
			else{
				//Crossed to next index
				flgCrossedThisIndex = TRUE;

			}

		}
		


	}while(!flgCrossedThisIndex);


	return FALSE;

}


/****************************************************************************************
Function:	CM40xVCDlg::LoadExtraFields(FILE *fptr)

Input:		
			fptr - Pointer to the open cfg file			

Return:		
			None
			
Desc:			
			Loads any extra settings in the cfg file and stores them in memory
			for later use. Extra settings are not index - config setting, instead
			they may be debug setting for the dll or any comments inserted by the
			user or any config setting that may be introduced in future. This routine
			scans every line in the file, if finds a line with no index config setting
			and is not a blank line then its treated as an extra field and stored
			in memory, for later use or to write it back when application is shutdown.


  
Created:	07.31.03


Changes:
		
******************************************************************************************/


void CM40xVCDlg::LoadExtraSetting(FILE *fptr)
{
	char pLine[500], pBack[500];
	int i,nLen;
	BOOLEAN flgIsBlankLine;
	fseek(fptr,0,0); //start from begining

	while((fgets(pLine,500,fptr) != NULL)){
		// Till we have not reached end of file
		nLen = strlen(pLine);
		flgIsBlankLine = TRUE;
		for(i=0;i<nLen;i++){
			if( ((pLine[i] >= 'a') && (pLine[i] <= 'z')) || ((pLine[i] >= 'A') && (pLine[i] <= 'Z'))){
				flgIsBlankLine = FALSE;
				break;
			}
		}
		if(flgIsBlankLine)
			continue;

		strcpy(pBack,pLine);
		if( (strstr(_strupr(pLine),"IP ADDRESS :") ==NULL) &&
			(strstr(_strupr(pLine),"SUBNET MASK:") ==NULL) &&
			(strstr(_strupr(pLine),"GATEWAY IP :") ==NULL) &&
			(strstr(_strupr(pLine),"DHCP TMOUT :") ==NULL) &&
			(strstr(_strupr(pLine),"SCAN AVG   :") ==NULL) &&
			(strstr(_strupr(pLine),"DIGITAL OUT:") ==NULL) &&
			(strstr(_strupr(pLine),"POLLED MODE:") ==NULL) &&
			(strstr(_strupr(pLine),"MULTI  CHAN:") ==NULL) &&
			(strstr(_strupr(pLine),"CAL.   SCAN:") ==NULL) &&
			(strstr(_strupr(pLine),"NUMBER CHAN:") ==NULL) &&
			(strstr(_strupr(pLine),"AC/DC  MODE:") ==NULL) &&
			(strstr(_strupr(pLine),"DISP   CHAN:") ==NULL) &&
			(strstr(_strupr(pLine),"VOLTS/DIV  :") ==NULL) &&
			(strstr(_strupr(pLine),"SCAN RATE  :") ==NULL) &&
			(strstr(_strupr(pLine),"GRAPHTIMEBASE  :") ==NULL) &&
			(strstr(_strupr(pLine),"NETWORK_EVENT_THREAD_PRIORITY") ==NULL) &&
			(strstr(_strupr(pLine),"NETWORK_POLL_THREAD_PRIORITY") ==NULL) && 
			(strstr(_strupr(pLine), "EX_AD0_START:") ==NULL) && 
			(strstr(_strupr(pLine), "EX_AD0_END:") ==NULL) && 
			(strstr(_strupr(pLine), "EX_AD1_START:") ==NULL) && 
			(strstr(_strupr(pLine), "EX_AD1_END:") ==NULL) && 
			(strstr(_strupr(pLine), "EX_AD6:") ==NULL) && 
			(strstr(_strupr(pLine), "EX_AD7:") ==NULL) && 
			(strstr(_strupr(pLine), "EX_CAL_SCAN:") ==NULL) && 
			(strstr(_strupr(pLine), "EX_MUX_INVERT:") ==NULL)){
			//This line is neither blank nor does it contain any index - config,
			// so this must be an extra setting 
			if(nNumExtraSetting == MAX_EXTRA_SETTING)
				return;  // all the mem slots for holding extra settings uses up so return			
			pExtraSetting[nNumExtraSetting].Format("%s",pBack);
			nNumExtraSetting++;			

		}



	}
    

}

















/****************************************************************************************
Function:	

Input:		

			

Return:		
			
Desc:			
			

  
Created:	07.31.03


Changes:
		
******************************************************************************************/










/****************************************************************************************
Function:	

Input:		

			

Return:		
			
Desc:			
			

  
Created:	07.31.03


Changes:
		
******************************************************************************************/
















/****************************************************************************************
Function:	

Input:		

			

Return:		
			
Desc:			
			

  
Created:


Changes:
		
******************************************************************************************/

void CM40xVCDlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnLButtonDblClk(nFlags, point);
}







/****************************************************************************************
Function:	BOOLEAN CM40xVCDlg::IsSafeToChangeIndex()

Input:					

Return:		
		TRUE - Safe to switch indices.Always returns TRUE when using callback or timer
		for new scan data acquisition.
		
		FALSE - Unsafe to switch indices

Desc:	
		If the second thread in the application is polling the dll for new scan data
		then this function waits 100ms for the thread to finish updating and to 
		release the mutex. If it fails to acquire the mutex then there must be a 
		deadlock; it pumps message to allow the second thread to finish updating the
		controls and release the mutex. flgWaitForIndexSwing is set to prevent the second
		from acquiring the mutex if it updates and releases the mutex before 500ms

  
Created:	11.4.03


Changes:
		
******************************************************************************************/


//DEL BOOLEAN CM40xVCDlg::IsSafeToChangeIndex()
//DEL {
//DEL 	
//DEL 
//DEL }

//DEL BOOLEAN CM40xVCDlg::flgUsingEventThread()
//DEL {
//DEL 
//DEL }

void CM40xVCDlg::SetMenuThreadPriority(BYTE bThreadPriority)
{
	theApp.pMyMenu = GetMenu();
	if(theApp.pMyMenu == NULL)
		return;
	theApp.pMyMenu->CheckMenuItem(IDC_THREAD_PRIORITY_HIGHEST,MF_UNCHECKED);
	theApp.pMyMenu->CheckMenuItem(IDC_THREAD_PRIORITY_ABOVE_NORMAL,MF_UNCHECKED);
	theApp.pMyMenu->CheckMenuItem(IDC_THREAD_PRIORITY_NORMAL,MF_UNCHECKED);
	theApp.pMyMenu->CheckMenuItem(IDC_THREAD_PRIORITY_BELOW_NORMAL,MF_UNCHECKED);
	theApp.pMyMenu->CheckMenuItem(IDC_THREAD_PRIORITY_LOWEST,MF_UNCHECKED);
	theApp.pMyMenu->CheckMenuItem(IDC_THREAD_PRIORITY_IDLE,MF_UNCHECKED);
	switch(bThreadPriority){

		case 5:
			theApp.pMyMenu->CheckMenuItem(IDC_THREAD_PRIORITY_HIGHEST,MF_CHECKED);
			break;

		case 4:
			theApp.pMyMenu->CheckMenuItem(IDC_THREAD_PRIORITY_ABOVE_NORMAL,MF_CHECKED);
			break;

		case 3:
			theApp.pMyMenu->CheckMenuItem(IDC_THREAD_PRIORITY_NORMAL,MF_CHECKED);
			break;

		case 2:
			theApp.pMyMenu->CheckMenuItem(IDC_THREAD_PRIORITY_BELOW_NORMAL,MF_CHECKED);
			break;

		case 1:
			theApp.pMyMenu->CheckMenuItem(IDC_THREAD_PRIORITY_LOWEST,MF_CHECKED);
			break;

		case 0:
			theApp.pMyMenu->CheckMenuItem(IDC_THREAD_PRIORITY_IDLE,MF_CHECKED);
			break;
	}

	if(flgUsingEventThread){
		bNetworkEventThreadPriority = bThreadPriority;
		theApp.pDLL_SetThreadPriority(1,bThreadPriority);
	}
	else{
		bNetworkPollThreadPriority = bThreadPriority;
		theApp.pDLL_SetThreadPriority(0,bThreadPriority);
	}

}

void CM40xVCDlg::OnThreadPriorityHighest() 
{
	// TODO: Add your command handler code here
	SetMenuThreadPriority(5);
	
}

void CM40xVCDlg::OnThreadPriorityAboveNormal() 
{
	// TODO: Add your command handler code here
	SetMenuThreadPriority(4);
	
}

void CM40xVCDlg::OnThreadPriorityNormal() 
{
	// TODO: Add your command handler code here
	SetMenuThreadPriority(3);
	
}

void CM40xVCDlg::OnThreadPriorityBelowNormal() 
{
	// TODO: Add your command handler code here
	SetMenuThreadPriority(2);	
}

void CM40xVCDlg::OnThreadPriorityLowest() 
{
	// TODO: Add your command handler code here
	SetMenuThreadPriority(1);
	
}

void CM40xVCDlg::OnThreadPriorityIdle() 
{
	// TODO: Add your command handler code here
	SetMenuThreadPriority(0);
	
}




void CM40xVCDlg::OnExScanSetup() 
{
	// TODO: Add your control notification handler code here
	ExSetupDlg.DoModal();
	
}



void CM40xVCDlg::OnChkExtended() 
{
	// TODO: Add your control notification handler code here
	if(m_ChkExtended.GetCheck()){
		if(flgNoCallback){
			if(Context[uSelected_Index].bExtCalScan){
				theApp.DLL_Scan_obj[uSelected_Index].bScanMode = EXTENDED_CAL_SCAN;
			}
			else{
				theApp.DLL_Scan_obj[uSelected_Index].bScanMode = EXTENDED_SCAN;
			}
		}
		else{
			AfxMessageBox("Extended scan is available ONLY in polled methods of reading data from the DLL. Shutdown application, edit callback.cfg for polled method and try again");		
		}
	}
	else{
		theApp.DLL_Scan_obj[uSelected_Index].bScanMode = SINGLE_CHAN_SCAN;
	}
	UpdateGUIState();
		
}


void CM40xVCDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	m_ExVoltDlg.ShowWindow(SW_SHOW);
	
}

void CM40xVCDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
		m_ExVoltDlg.ShowWindow(SW_HIDE);
	
}

void CM40xVCDlg::SetSubChan(BYTE bSubChan)
{
	BYTE i;
	bSubChan = bSubChan & 0x0F;
	for(i=0;i<4;i++){ 
		if(bSubChan & (1 << i)){
			m_pDigiOut[i]->SetCheck(1);
			bLastDigOut |= (1 << i);			
		}
		else{
			m_pDigiOut[i]->SetCheck(0);						
			bLastDigOut &= ~(1 << i);
		}
	}		
}

BYTE CM40xVCDlg::GetExActiveChan()
{
	BYTE bTemp;
	bTemp = (bCurSelChan << 4) + (bLastDigOut & 0x0F);
	if(bTemp >= 0x20)
		bTemp = bTemp & 0xF0;	//no subchans for chan6 and 7
	return bTemp;

}



/*
	Depending on the AD range select the number of decimal
	places for atleast 22-bits resolution
*/



CString FormatVolt(double fVolt, UINT uIndex)
{
	CString sRet;
	switch(theApp.DLL_Scan_obj[uIndex].bADRange){
		case 2:
		case 7:
			// +/- 1V, +/-2V
			sRet.Format("%10.7f",fVolt);
			break;

		case 3:
			// +- 0.1V
		case 4:
			// +- 0.2V
		case 5:
			// - 0.045V
			sRet.Format("%11.8f",fVolt);
			break;

		case 6:
			// +- 7V
			sRet.Format("%9.6f",fVolt);
			break;


		default:
			// +- 5V
			sRet.Format("%9.6f",fVolt);
			break;
	}	
	return sRet;	
}

void CM40xVCDlg::OnFileRtchosttimediff() 
{
	// TODO: Add your command handler code here
	ULONG ulDiff;
	if(theApp.pDLL_IsFirmwareVersion(&theApp.DLL_Scan_obj[uSelected_Index],8,23,2006)){
		if(theApp.pDLL_GetTimeDiff(&theApp.DLL_Scan_obj[uSelected_Index],&ulDiff) == COMMAND_OK){
			WriteLogEntry("The RTC - Host time diff is %ld secs", ulDiff);
		}
	}
	else{
		AfxMessageBox("The M401 firmware version does not support this command");
	}
}
